#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR683sony/IR683sony.c"
#line 12 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR683sony/IR683sony.c"
sbit ir_rx at GPIO.B0;


void get_mark_time(void);



unsigned char counter = 0;
unsigned char shadow = 0;
unsigned char bitcount;
unsigned char ir_address;
unsigned char ir_command;
unsigned int mark_time;

void interrupt() {

 if (INTCON.T0IF) {
 counter++;
 INTCON.T0IF = 0;
 }
}

void main() {

 CMCON0 = 7;
 ANSEL = 0;
 OSCCON = 0x71;
 OPTION_REG = 0x04;
 TRISIO = 0x01;
 GPIO = 0;



 INTCON.GIE = 1;
 INTCON.T0IE = 1;

 while(1){
 ir_command = 0;
 ir_address = 0;
 get_mark_time();
 if ((mark_time > 0x80) && (mark_time < 0xB0)){

 for(bitcount = 0 ; bitcount < 7 ; bitcount++){
 get_mark_time();
 ir_command >>= 1;
 ir_command &= 0x7f;
 if (mark_time > 0x40){
 ir_command ^= 0x80;
 }
 }
 ir_command >>= 1;
 ir_command &= 0x7F;

 for(bitcount = 0 ; bitcount < 5 ; bitcount++){
 get_mark_time();
 ir_address >>= 1;
 ir_address &= 0x7f;
 if (mark_time > 0x40){
 ir_address ^= 0x80;
 }
 }
 ir_address >>= 3;
 ir_address &= 0x1F;

 }

 if(ir_address == 1){
 if(ir_command == 0){
 shadow ^= 0x02;
 GPIO = shadow;
 }
 if(ir_command == 1){
 shadow ^= 0x04;
 GPIO = shadow;
 }
 if(ir_command == 2){
 shadow ^= 0x10;
 GPIO = shadow;
 }
 if(ir_command == 3){
 shadow ^= 0x20;
 GPIO = shadow;
 }
 if(ir_command == 8){
 shadow = 0x36;
 GPIO = shadow;
 }
 if(ir_command == 9){
 shadow = 0x00;
 GPIO = shadow;
 }
 Delay_ms(200);
 }
 }
}


void get_mark_time(void){
 while(ir_rx);
 counter=0;
 TMR0 = 0;
 while(!ir_rx);
 mark_time = (counter << 8) + TMR0;

}
