
_main:

;IRTx.c,53 :: 		void main() {
;IRTx.c,54 :: 		ANSELC = 0;                          // Configure PORTC pins as digital
	CLRF        ANSELC+0 
;IRTx.c,55 :: 		TRISC = 0;                           // all output
	CLRF        TRISC+0 
;IRTx.c,56 :: 		ANSELD = 0;                          // Configure PORTD pins as digital
	CLRF        ANSELD+0 
;IRTx.c,57 :: 		TRISD = 0xff;                        // all input
	MOVLW       255
	MOVWF       TRISD+0 
;IRTx.c,58 :: 		toggle = 0;                          // initialise (not really needed)
	CLRF        _toggle+0 
;IRTx.c,60 :: 		UART1_Init(9600);                    // Initialize UART module at 9600 bps
	BSF         BAUDCON+0, 3, 0
	MOVLW       3
	MOVWF       SPBRGH+0 
	MOVLW       64
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;IRTx.c,61 :: 		Delay_ms(100);                       // Wait for UART module to stabilize
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_main0:
	DECFSZ      R13, 1, 1
	BRA         L_main0
	DECFSZ      R12, 1, 1
	BRA         L_main0
	DECFSZ      R11, 1, 1
	BRA         L_main0
;IRTx.c,63 :: 		UART1_Write_Text("\r\n\nEasyPIC7 IR Transmit\r\n\n");
	MOVLW       ?lstr1_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr1_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,64 :: 		UART1_Write_Text("Set pull-downs on all PORT D inputs\r\n");
	MOVLW       ?lstr2_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr2_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,65 :: 		UART1_Write_Text("Set button press level to high\r\n");
	MOVLW       ?lstr3_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr3_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,66 :: 		UART1_Write_Text("Connect IR LED with 33 Ohm resitor in series onto pin C2\r\n");
	MOVLW       ?lstr4_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr4_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,67 :: 		UART1_Write_Text("Take a Button on PORTD high as below:\r\n\n");
	MOVLW       ?lstr5_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr5_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,68 :: 		UART1_Write_Text("0 Simple Test 20mS mark, 100mS space 38KHz\r\n");
	MOVLW       ?lstr6_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr6_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,69 :: 		UART1_Write_Text("1 Sharp 0x13 0xa4\r\n");
	MOVLW       ?lstr7_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr7_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,70 :: 		UART1_Write_Text("2 PT2248 Toshiba\r\n");
	MOVLW       ?lstr8_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr8_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,71 :: 		UART1_Write_Text("3 NEC 1234 56 (A9)\r\n");
	MOVLW       ?lstr9_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr9_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,72 :: 		UART1_Write_Text("4 Turn Sony TV on/off\r\n");
	MOVLW       ?lstr10_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr10_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,73 :: 		UART1_Write_Text("5 RC5\r\n");
	MOVLW       ?lstr11_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr11_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,74 :: 		UART1_Write_Text("6 RC6 mode 0 12 34\r\n");
	MOVLW       ?lstr12_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr12_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,75 :: 		UART1_Write_Text("7 RC6 mode 6A-32\r\n");
	MOVLW       ?lstr13_IRTx+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr13_IRTx+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IRTx.c,77 :: 		PWM1_Init(38000);                    // Initialize PWM1 (and PWM2) module at 38KHz
	BCF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	MOVLW       209
	MOVWF       PR2+0, 0
	CALL        _PWM1_Init+0, 0
;IRTx.c,78 :: 		PWM1_Set_Duty(80);                   // approx 1/3 duty cycle is typical for IR
	MOVLW       80
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;IRTx.c,80 :: 		while(1){                            // main loop
L_main1:
;IRTx.c,81 :: 		select = PORTD;                  // read 8 buttons on PORTD
	MOVF        PORTD+0, 0 
	MOVWF       _select+0 
;IRTx.c,83 :: 		if(select == 1){                 // button RD0 pressed (and no others)
	MOVF        _select+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_main3
;IRTx.c,84 :: 		set_38();                    // change IR frequency
	CALL        _set_38+0, 0
;IRTx.c,85 :: 		PWM1_Start();
	CALL        _PWM1_Start+0, 0
;IRTx.c,86 :: 		Delay_ms(20);
	MOVLW       208
	MOVWF       R12, 0
	MOVLW       201
	MOVWF       R13, 0
L_main4:
	DECFSZ      R13, 1, 1
	BRA         L_main4
	DECFSZ      R12, 1, 1
	BRA         L_main4
	NOP
	NOP
;IRTx.c,87 :: 		PWM1_Stop();
	CALL        _PWM1_Stop+0, 0
;IRTx.c,88 :: 		Delay_ms(100);
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_main5:
	DECFSZ      R13, 1, 1
	BRA         L_main5
	DECFSZ      R12, 1, 1
	BRA         L_main5
	DECFSZ      R11, 1, 1
	BRA         L_main5
;IRTx.c,89 :: 		}
L_main3:
;IRTx.c,90 :: 		if(select == 2){                 // button RD1 pressed (and no others)
	MOVF        _select+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_main6
;IRTx.c,91 :: 		ir_byte[1]=0x13;             // Sharp 5 bit address
	MOVLW       19
	MOVWF       _ir_byte+1 
;IRTx.c,92 :: 		ir_byte[2]=0xa4;             // Sharp 7 bit command
	MOVLW       164
	MOVWF       _ir_byte+2 
;IRTx.c,93 :: 		send_sharp();                // and send it...
	CALL        _send_sharp+0, 0
;IRTx.c,94 :: 		}
L_main6:
;IRTx.c,95 :: 		if(select == 4){                 // button RD2 pressed (and no others)
	MOVF        _select+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_main7
;IRTx.c,96 :: 		ir_byte[1]=4;                // Toshiba 3 bit code (address)
	MOVLW       4
	MOVWF       _ir_byte+1 
;IRTx.c,97 :: 		ir_byte[2]=4;                // one H and two S bits
	MOVLW       4
	MOVWF       _ir_byte+2 
;IRTx.c,98 :: 		ir_byte[3]=8;                // 6 key-code bits
	MOVLW       8
	MOVWF       _ir_byte+3 
;IRTx.c,99 :: 		send_tosh();                 // and send it...
	CALL        _send_tosh+0, 0
;IRTx.c,100 :: 		}
L_main7:
;IRTx.c,101 :: 		if(select == 8){                 // button RD3 pressed (and no others)
	MOVF        _select+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_main8
;IRTx.c,102 :: 		ir_byte[1]=0x12;             // NEC address
	MOVLW       18
	MOVWF       _ir_byte+1 
;IRTx.c,103 :: 		ir_byte[2]=0x34;             // NEC address
	MOVLW       52
	MOVWF       _ir_byte+2 
;IRTx.c,104 :: 		ir_byte[3]=0x56;             // NEC data
	MOVLW       86
	MOVWF       _ir_byte+3 
;IRTx.c,105 :: 		send_nec();                  // and send it...
	CALL        _send_nec+0, 0
;IRTx.c,106 :: 		}
L_main8:
;IRTx.c,107 :: 		if(select == 16){                // button RD4 pressed (and no others)
	MOVF        _select+0, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L_main9
;IRTx.c,108 :: 		ir_byte[1]=0x15;             // Sony 7 bit command (0x15=power)
	MOVLW       21
	MOVWF       _ir_byte+1 
;IRTx.c,109 :: 		ir_byte[2]=1;                // Sony 5 bit address (1=TV)
	MOVLW       1
	MOVWF       _ir_byte+2 
;IRTx.c,110 :: 		send_sony();                 // and send it...
	CALL        _send_sony+0, 0
;IRTx.c,111 :: 		send_sony();                 // later TVs need two messages (spaced 26 mS apart)
	CALL        _send_sony+0, 0
;IRTx.c,112 :: 		}
L_main9:
;IRTx.c,113 :: 		if(select == 32){                // button RD5 pressed (and no others)
	MOVF        _select+0, 0 
	XORLW       32
	BTFSS       STATUS+0, 2 
	GOTO        L_main10
;IRTx.c,114 :: 		ir_byte[1]=0x00;             // RC5 5 bit address (0=TV)
	CLRF        _ir_byte+1 
;IRTx.c,115 :: 		ir_byte[2]=0x0d;             // RC5 6 bit command (13=mute)
	MOVLW       13
	MOVWF       _ir_byte+2 
;IRTx.c,116 :: 		send_rc5();                  // and send it...
	CALL        _send_rc5+0, 0
;IRTx.c,117 :: 		}
L_main10:
;IRTx.c,118 :: 		if(select == 64){                // button RD6 pressed (and no others)
	MOVF        _select+0, 0 
	XORLW       64
	BTFSS       STATUS+0, 2 
	GOTO        L_main11
;IRTx.c,119 :: 		ir_byte[1]=0x12;             // RC6 8 bit control
	MOVLW       18
	MOVWF       _ir_byte+1 
;IRTx.c,120 :: 		ir_byte[2]=0x34;             // RC6 8 bit information
	MOVLW       52
	MOVWF       _ir_byte+2 
;IRTx.c,121 :: 		send_rc6m0();                // and send it...
	CALL        _send_rc6m0+0, 0
;IRTx.c,122 :: 		}
L_main11:
;IRTx.c,123 :: 		if(select == 128){               // button RD7 pressed (and no others)
	MOVF        _select+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_main12
;IRTx.c,124 :: 		ir_byte[1]=0x00;             // RC6
	CLRF        _ir_byte+1 
;IRTx.c,125 :: 		ir_byte[2]=0x22;             // RC6
	MOVLW       34
	MOVWF       _ir_byte+2 
;IRTx.c,126 :: 		ir_byte[3]=0x10;             // RC6
	MOVLW       16
	MOVWF       _ir_byte+3 
;IRTx.c,127 :: 		ir_byte[4]=0x0c;             // RC6
	MOVLW       12
	MOVWF       _ir_byte+4 
;IRTx.c,128 :: 		send_rc6m6();                // and send it...
	CALL        _send_rc6m6+0, 0
;IRTx.c,129 :: 		}
L_main12:
;IRTx.c,130 :: 		select = 0;
	CLRF        _select+0 
;IRTx.c,131 :: 		}
	GOTO        L_main1
;IRTx.c,134 :: 		}
L_end_main:
	GOTO        $+0
; end of _main

_set_36:

;IRTx.c,138 :: 		void set_36(){
;IRTx.c,139 :: 		PR2 = 220;
	MOVLW       220
	MOVWF       PR2+0 
;IRTx.c,140 :: 		}
L_end_set_36:
	RETURN      0
; end of _set_36

_set_38:

;IRTx.c,143 :: 		void set_38(){
;IRTx.c,144 :: 		PR2 = 210;
	MOVLW       210
	MOVWF       PR2+0 
;IRTx.c,145 :: 		}
L_end_set_38:
	RETURN      0
; end of _set_38

_set_40:

;IRTx.c,148 :: 		void set_40(){
;IRTx.c,149 :: 		PR2 = 200;
	MOVLW       200
	MOVWF       PR2+0 
;IRTx.c,150 :: 		}
L_end_set_40:
	RETURN      0
; end of _set_40

_send_tosh:

;IRTx.c,155 :: 		void send_tosh(void){
;IRTx.c,158 :: 		set_38();                                  // 38 KHz IR
	CALL        _set_38+0, 0
;IRTx.c,159 :: 		Delay_ms(100);                             // ensure some no-data time
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_tosh15:
	DECFSZ      R13, 1, 1
	BRA         L_send_tosh15
	DECFSZ      R12, 1, 1
	BRA         L_send_tosh15
	DECFSZ      R11, 1, 1
	BRA         L_send_tosh15
;IRTx.c,161 :: 		for(bitnum=0 ; bitnum < 3 ; bitnum++){     // 3 bit address
	CLRF        send_tosh_bitnum_L0+0 
L_send_tosh16:
	MOVLW       3
	SUBWF       send_tosh_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_tosh17
;IRTx.c,162 :: 		tosh_bit(ir_byte[1] >> (2-bitnum));     // MSB sent first
	MOVF        send_tosh_bitnum_L0+0, 0 
	SUBLW       2
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+1, 0 
	MOVWF       FARG_tosh_bit_rc5_bitval+0 
	MOVF        R0, 0 
L__send_tosh173:
	BZ          L__send_tosh174
	RRCF        FARG_tosh_bit_rc5_bitval+0, 1 
	BCF         FARG_tosh_bit_rc5_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_tosh173
L__send_tosh174:
	CALL        _tosh_bit+0, 0
;IRTx.c,161 :: 		for(bitnum=0 ; bitnum < 3 ; bitnum++){     // 3 bit address
	INCF        send_tosh_bitnum_L0+0, 1 
;IRTx.c,163 :: 		}
	GOTO        L_send_tosh16
L_send_tosh17:
;IRTx.c,164 :: 		for(bitnum=0 ; bitnum < 3 ; bitnum++){     // H bit and 2 S bits
	CLRF        send_tosh_bitnum_L0+0 
L_send_tosh19:
	MOVLW       3
	SUBWF       send_tosh_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_tosh20
;IRTx.c,165 :: 		tosh_bit(ir_byte[2] >> (2-bitnum));     // MSB sent first
	MOVF        send_tosh_bitnum_L0+0, 0 
	SUBLW       2
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+2, 0 
	MOVWF       FARG_tosh_bit_rc5_bitval+0 
	MOVF        R0, 0 
L__send_tosh175:
	BZ          L__send_tosh176
	RRCF        FARG_tosh_bit_rc5_bitval+0, 1 
	BCF         FARG_tosh_bit_rc5_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_tosh175
L__send_tosh176:
	CALL        _tosh_bit+0, 0
;IRTx.c,164 :: 		for(bitnum=0 ; bitnum < 3 ; bitnum++){     // H bit and 2 S bits
	INCF        send_tosh_bitnum_L0+0, 1 
;IRTx.c,166 :: 		}
	GOTO        L_send_tosh19
L_send_tosh20:
;IRTx.c,167 :: 		for(bitnum=0 ; bitnum < 6 ; bitnum++){     // 6 bit key-code
	CLRF        send_tosh_bitnum_L0+0 
L_send_tosh22:
	MOVLW       6
	SUBWF       send_tosh_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_tosh23
;IRTx.c,168 :: 		tosh_bit(ir_byte[3] >> (5-bitnum));
	MOVF        send_tosh_bitnum_L0+0, 0 
	SUBLW       5
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+3, 0 
	MOVWF       FARG_tosh_bit_rc5_bitval+0 
	MOVF        R0, 0 
L__send_tosh177:
	BZ          L__send_tosh178
	RRCF        FARG_tosh_bit_rc5_bitval+0, 1 
	BCF         FARG_tosh_bit_rc5_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_tosh177
L__send_tosh178:
	CALL        _tosh_bit+0, 0
;IRTx.c,167 :: 		for(bitnum=0 ; bitnum < 6 ; bitnum++){     // 6 bit key-code
	INCF        send_tosh_bitnum_L0+0, 1 
;IRTx.c,169 :: 		}
	GOTO        L_send_tosh22
L_send_tosh23:
;IRTx.c,170 :: 		PWM1_Stop();
	CALL        _PWM1_Stop+0, 0
;IRTx.c,171 :: 		Delay_ms(100);                             // ensure some no-data time
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_tosh25:
	DECFSZ      R13, 1, 1
	BRA         L_send_tosh25
	DECFSZ      R12, 1, 1
	BRA         L_send_tosh25
	DECFSZ      R11, 1, 1
	BRA         L_send_tosh25
;IRTx.c,172 :: 		}
L_end_send_tosh:
	RETURN      0
; end of _send_tosh

_send_rc6m0:

;IRTx.c,177 :: 		void send_rc6m0(void){
;IRTx.c,180 :: 		set_36();                                  // 36 KHz IR
	CALL        _set_36+0, 0
;IRTx.c,181 :: 		Delay_ms(100);                             // ensure some no-data time
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_rc6m026:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc6m026
	DECFSZ      R12, 1, 1
	BRA         L_send_rc6m026
	DECFSZ      R11, 1, 1
	BRA         L_send_rc6m026
;IRTx.c,182 :: 		PWM1_Start();                              // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,183 :: 		Delay_us(2666);                            // 2.666mS mark leader
	MOVLW       28
	MOVWF       R12, 0
	MOVLW       177
	MOVWF       R13, 0
L_send_rc6m027:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc6m027
	DECFSZ      R12, 1, 1
	BRA         L_send_rc6m027
	NOP
	NOP
;IRTx.c,184 :: 		PWM1_Stop();                               // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,185 :: 		Delay_us(889);                             // 889uS space ends leader
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_send_rc6m028:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc6m028
	DECFSZ      R12, 1, 1
	BRA         L_send_rc6m028
;IRTx.c,186 :: 		rc6_1();                                   // start bit of one
	CALL        _rc6_1+0, 0
;IRTx.c,187 :: 		rc6_0();                                   // first mode bit of zero
	CALL        _rc6_0+0, 0
;IRTx.c,188 :: 		rc6_0();                                   // second mode bit of zer0
	CALL        _rc6_0+0, 0
;IRTx.c,189 :: 		rc6_0();                                   // third mode bit of zero
	CALL        _rc6_0+0, 0
;IRTx.c,190 :: 		rc6_double_bit(toggle);                    // send double size toggle bit
	MOVF        _toggle+0, 0 
	MOVWF       FARG_rc6_double_bit_bitval+0 
	CALL        _rc6_double_bit+0, 0
;IRTx.c,191 :: 		toggle++;                                  // toggle ready for next time
	INCF        _toggle+0, 1 
;IRTx.c,193 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bit address
	CLRF        send_rc6m0_bitnum_L0+0 
L_send_rc6m029:
	MOVLW       8
	SUBWF       send_rc6m0_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_rc6m030
;IRTx.c,194 :: 		ir_rc6_bit(ir_byte[1] >> (7-bitnum));     // MSB sent first
	MOVF        send_rc6m0_bitnum_L0+0, 0 
	SUBLW       7
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+1, 0 
	MOVWF       FARG_ir_rc6_bit_rc6_bitval+0 
	MOVF        R0, 0 
L__send_rc6m0180:
	BZ          L__send_rc6m0181
	RRCF        FARG_ir_rc6_bit_rc6_bitval+0, 1 
	BCF         FARG_ir_rc6_bit_rc6_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_rc6m0180
L__send_rc6m0181:
	CALL        _ir_rc6_bit+0, 0
;IRTx.c,193 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bit address
	INCF        send_rc6m0_bitnum_L0+0, 1 
;IRTx.c,195 :: 		}
	GOTO        L_send_rc6m029
L_send_rc6m030:
;IRTx.c,196 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bit command
	CLRF        send_rc6m0_bitnum_L0+0 
L_send_rc6m032:
	MOVLW       8
	SUBWF       send_rc6m0_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_rc6m033
;IRTx.c,197 :: 		ir_rc6_bit(ir_byte[2] >> (7-bitnum));
	MOVF        send_rc6m0_bitnum_L0+0, 0 
	SUBLW       7
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+2, 0 
	MOVWF       FARG_ir_rc6_bit_rc6_bitval+0 
	MOVF        R0, 0 
L__send_rc6m0182:
	BZ          L__send_rc6m0183
	RRCF        FARG_ir_rc6_bit_rc6_bitval+0, 1 
	BCF         FARG_ir_rc6_bit_rc6_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_rc6m0182
L__send_rc6m0183:
	CALL        _ir_rc6_bit+0, 0
;IRTx.c,196 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bit command
	INCF        send_rc6m0_bitnum_L0+0, 1 
;IRTx.c,198 :: 		}
	GOTO        L_send_rc6m032
L_send_rc6m033:
;IRTx.c,199 :: 		PWM1_Stop();
	CALL        _PWM1_Stop+0, 0
;IRTx.c,200 :: 		Delay_ms(100);                             // ensure some no-data time
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_rc6m035:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc6m035
	DECFSZ      R12, 1, 1
	BRA         L_send_rc6m035
	DECFSZ      R11, 1, 1
	BRA         L_send_rc6m035
;IRTx.c,201 :: 		}
L_end_send_rc6m0:
	RETURN      0
; end of _send_rc6m0

_send_rc6m6:

;IRTx.c,205 :: 		void send_rc6m6(void){
;IRTx.c,208 :: 		set_36();                                  // 36 KHz IR
	CALL        _set_36+0, 0
;IRTx.c,209 :: 		Delay_ms(100);                             // ensure some no-data time
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_rc6m636:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc6m636
	DECFSZ      R12, 1, 1
	BRA         L_send_rc6m636
	DECFSZ      R11, 1, 1
	BRA         L_send_rc6m636
;IRTx.c,210 :: 		PWM1_Start();                              // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,211 :: 		Delay_us(2666);                            // 2.666mS mark leader
	MOVLW       28
	MOVWF       R12, 0
	MOVLW       177
	MOVWF       R13, 0
L_send_rc6m637:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc6m637
	DECFSZ      R12, 1, 1
	BRA         L_send_rc6m637
	NOP
	NOP
;IRTx.c,212 :: 		PWM1_Stop();                               // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,213 :: 		Delay_us(889);                             // 889uS space ends leader
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_send_rc6m638:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc6m638
	DECFSZ      R12, 1, 1
	BRA         L_send_rc6m638
;IRTx.c,214 :: 		rc6_1();                                   // start bit of one
	CALL        _rc6_1+0, 0
;IRTx.c,215 :: 		rc6_1();                                   // first mode bit of one
	CALL        _rc6_1+0, 0
;IRTx.c,216 :: 		rc6_1();                                   // second mode bit of one
	CALL        _rc6_1+0, 0
;IRTx.c,217 :: 		rc6_0();                                   // third mode bit of zero
	CALL        _rc6_0+0, 0
;IRTx.c,218 :: 		rc6_double_bit(toggle);                    // send double size toggle bit
	MOVF        _toggle+0, 0 
	MOVWF       FARG_rc6_double_bit_bitval+0 
	CALL        _rc6_double_bit+0, 0
;IRTx.c,219 :: 		toggle++;                                  // toggle ready for next time
	INCF        _toggle+0, 1 
;IRTx.c,221 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bits
	CLRF        send_rc6m6_bitnum_L0+0 
L_send_rc6m639:
	MOVLW       8
	SUBWF       send_rc6m6_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_rc6m640
;IRTx.c,222 :: 		ir_rc6_bit(ir_byte[1] >> (7-bitnum));     // MSB sent first
	MOVF        send_rc6m6_bitnum_L0+0, 0 
	SUBLW       7
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+1, 0 
	MOVWF       FARG_ir_rc6_bit_rc6_bitval+0 
	MOVF        R0, 0 
L__send_rc6m6185:
	BZ          L__send_rc6m6186
	RRCF        FARG_ir_rc6_bit_rc6_bitval+0, 1 
	BCF         FARG_ir_rc6_bit_rc6_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_rc6m6185
L__send_rc6m6186:
	CALL        _ir_rc6_bit+0, 0
;IRTx.c,221 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bits
	INCF        send_rc6m6_bitnum_L0+0, 1 
;IRTx.c,223 :: 		}
	GOTO        L_send_rc6m639
L_send_rc6m640:
;IRTx.c,224 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bits
	CLRF        send_rc6m6_bitnum_L0+0 
L_send_rc6m642:
	MOVLW       8
	SUBWF       send_rc6m6_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_rc6m643
;IRTx.c,225 :: 		ir_rc6_bit(ir_byte[2] >> (7-bitnum));
	MOVF        send_rc6m6_bitnum_L0+0, 0 
	SUBLW       7
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+2, 0 
	MOVWF       FARG_ir_rc6_bit_rc6_bitval+0 
	MOVF        R0, 0 
L__send_rc6m6187:
	BZ          L__send_rc6m6188
	RRCF        FARG_ir_rc6_bit_rc6_bitval+0, 1 
	BCF         FARG_ir_rc6_bit_rc6_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_rc6m6187
L__send_rc6m6188:
	CALL        _ir_rc6_bit+0, 0
;IRTx.c,224 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bits
	INCF        send_rc6m6_bitnum_L0+0, 1 
;IRTx.c,226 :: 		}
	GOTO        L_send_rc6m642
L_send_rc6m643:
;IRTx.c,227 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bits
	CLRF        send_rc6m6_bitnum_L0+0 
L_send_rc6m645:
	MOVLW       8
	SUBWF       send_rc6m6_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_rc6m646
;IRTx.c,228 :: 		ir_rc6_bit(ir_byte[3] >> (7-bitnum));     // MSB sent first
	MOVF        send_rc6m6_bitnum_L0+0, 0 
	SUBLW       7
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+3, 0 
	MOVWF       FARG_ir_rc6_bit_rc6_bitval+0 
	MOVF        R0, 0 
L__send_rc6m6189:
	BZ          L__send_rc6m6190
	RRCF        FARG_ir_rc6_bit_rc6_bitval+0, 1 
	BCF         FARG_ir_rc6_bit_rc6_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_rc6m6189
L__send_rc6m6190:
	CALL        _ir_rc6_bit+0, 0
;IRTx.c,227 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bits
	INCF        send_rc6m6_bitnum_L0+0, 1 
;IRTx.c,229 :: 		}
	GOTO        L_send_rc6m645
L_send_rc6m646:
;IRTx.c,230 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bits
	CLRF        send_rc6m6_bitnum_L0+0 
L_send_rc6m648:
	MOVLW       8
	SUBWF       send_rc6m6_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_rc6m649
;IRTx.c,231 :: 		ir_rc6_bit(ir_byte[4] >> (7-bitnum));
	MOVF        send_rc6m6_bitnum_L0+0, 0 
	SUBLW       7
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+4, 0 
	MOVWF       FARG_ir_rc6_bit_rc6_bitval+0 
	MOVF        R0, 0 
L__send_rc6m6191:
	BZ          L__send_rc6m6192
	RRCF        FARG_ir_rc6_bit_rc6_bitval+0, 1 
	BCF         FARG_ir_rc6_bit_rc6_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_rc6m6191
L__send_rc6m6192:
	CALL        _ir_rc6_bit+0, 0
;IRTx.c,230 :: 		for(bitnum=0 ; bitnum < 8 ; bitnum++){     // 8 bits
	INCF        send_rc6m6_bitnum_L0+0, 1 
;IRTx.c,232 :: 		}
	GOTO        L_send_rc6m648
L_send_rc6m649:
;IRTx.c,233 :: 		PWM1_Stop();
	CALL        _PWM1_Stop+0, 0
;IRTx.c,234 :: 		Delay_ms(100);                             // ensure some no-data time
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_rc6m651:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc6m651
	DECFSZ      R12, 1, 1
	BRA         L_send_rc6m651
	DECFSZ      R11, 1, 1
	BRA         L_send_rc6m651
;IRTx.c,235 :: 		}
L_end_send_rc6m6:
	RETURN      0
; end of _send_rc6m6

_send_rc5:

;IRTx.c,239 :: 		void send_rc5(void){
;IRTx.c,242 :: 		set_36();                                  // 36 KHz IR
	CALL        _set_36+0, 0
;IRTx.c,243 :: 		Delay_ms(100);                             // ensure some no-data time
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_rc552:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc552
	DECFSZ      R12, 1, 1
	BRA         L_send_rc552
	DECFSZ      R11, 1, 1
	BRA         L_send_rc552
;IRTx.c,244 :: 		rc5_1();                                   // first of two start bits of one
	CALL        _rc5_1+0, 0
;IRTx.c,245 :: 		rc5_1();                                   // second of two start bits of one
	CALL        _rc5_1+0, 0
;IRTx.c,246 :: 		ir_rc5_bit(toggle);                           // send toggle bit
	MOVF        _toggle+0, 0 
	MOVWF       FARG_ir_rc5_bit_rc5_bitval+0 
	CALL        _ir_rc5_bit+0, 0
;IRTx.c,247 :: 		toggle++;                                  // toggle ready for next time
	INCF        _toggle+0, 1 
;IRTx.c,249 :: 		for(bitnum=0 ; bitnum < 5 ; bitnum++){     // 5 bit address
	CLRF        send_rc5_bitnum_L0+0 
L_send_rc553:
	MOVLW       5
	SUBWF       send_rc5_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_rc554
;IRTx.c,250 :: 		ir_rc5_bit(ir_byte[1] >> (4-bitnum));     // MSB sent first
	MOVF        send_rc5_bitnum_L0+0, 0 
	SUBLW       4
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+1, 0 
	MOVWF       FARG_ir_rc5_bit_rc5_bitval+0 
	MOVF        R0, 0 
L__send_rc5194:
	BZ          L__send_rc5195
	RRCF        FARG_ir_rc5_bit_rc5_bitval+0, 1 
	BCF         FARG_ir_rc5_bit_rc5_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_rc5194
L__send_rc5195:
	CALL        _ir_rc5_bit+0, 0
;IRTx.c,249 :: 		for(bitnum=0 ; bitnum < 5 ; bitnum++){     // 5 bit address
	INCF        send_rc5_bitnum_L0+0, 1 
;IRTx.c,251 :: 		}
	GOTO        L_send_rc553
L_send_rc554:
;IRTx.c,252 :: 		for(bitnum=0 ; bitnum < 6 ; bitnum++){     // 6 bit command
	CLRF        send_rc5_bitnum_L0+0 
L_send_rc556:
	MOVLW       6
	SUBWF       send_rc5_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_rc557
;IRTx.c,253 :: 		ir_rc5_bit(ir_byte[2] >> (5-bitnum));
	MOVF        send_rc5_bitnum_L0+0, 0 
	SUBLW       5
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        _ir_byte+2, 0 
	MOVWF       FARG_ir_rc5_bit_rc5_bitval+0 
	MOVF        R0, 0 
L__send_rc5196:
	BZ          L__send_rc5197
	RRCF        FARG_ir_rc5_bit_rc5_bitval+0, 1 
	BCF         FARG_ir_rc5_bit_rc5_bitval+0, 7 
	ADDLW       255
	GOTO        L__send_rc5196
L__send_rc5197:
	CALL        _ir_rc5_bit+0, 0
;IRTx.c,252 :: 		for(bitnum=0 ; bitnum < 6 ; bitnum++){     // 6 bit command
	INCF        send_rc5_bitnum_L0+0, 1 
;IRTx.c,254 :: 		}
	GOTO        L_send_rc556
L_send_rc557:
;IRTx.c,255 :: 		PWM1_Stop();
	CALL        _PWM1_Stop+0, 0
;IRTx.c,256 :: 		Delay_ms(100);                             // ensure some no-data time
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_rc559:
	DECFSZ      R13, 1, 1
	BRA         L_send_rc559
	DECFSZ      R12, 1, 1
	BRA         L_send_rc559
	DECFSZ      R11, 1, 1
	BRA         L_send_rc559
;IRTx.c,257 :: 		}
L_end_send_rc5:
	RETURN      0
; end of _send_rc5

_tosh_0:

;IRTx.c,260 :: 		void tosh_0(void){
;IRTx.c,261 :: 		PWM1_Start();                        // mark a
	CALL        _PWM1_Start+0, 0
;IRTx.c,262 :: 		Delay_us(422);
	MOVLW       5
	MOVWF       R12, 0
	MOVLW       97
	MOVWF       R13, 0
L_tosh_060:
	DECFSZ      R13, 1, 1
	BRA         L_tosh_060
	DECFSZ      R12, 1, 1
	BRA         L_tosh_060
;IRTx.c,263 :: 		PWM1_Stop();                         // space 3a
	CALL        _PWM1_Stop+0, 0
;IRTx.c,264 :: 		Delay_us(1266);
	MOVLW       14
	MOVWF       R12, 0
	MOVLW       37
	MOVWF       R13, 0
L_tosh_061:
	DECFSZ      R13, 1, 1
	BRA         L_tosh_061
	DECFSZ      R12, 1, 1
	BRA         L_tosh_061
	NOP
	NOP
;IRTx.c,265 :: 		}
L_end_tosh_0:
	RETURN      0
; end of _tosh_0

_tosh_1:

;IRTx.c,268 :: 		void tosh_1(void){
;IRTx.c,269 :: 		PWM1_Start();                        // mark 3a
	CALL        _PWM1_Start+0, 0
;IRTx.c,270 :: 		Delay_us(1266);
	MOVLW       14
	MOVWF       R12, 0
	MOVLW       37
	MOVWF       R13, 0
L_tosh_162:
	DECFSZ      R13, 1, 1
	BRA         L_tosh_162
	DECFSZ      R12, 1, 1
	BRA         L_tosh_162
	NOP
	NOP
;IRTx.c,271 :: 		PWM1_Stop();                         // space a
	CALL        _PWM1_Stop+0, 0
;IRTx.c,272 :: 		Delay_us(422);
	MOVLW       5
	MOVWF       R12, 0
	MOVLW       97
	MOVWF       R13, 0
L_tosh_163:
	DECFSZ      R13, 1, 1
	BRA         L_tosh_163
	DECFSZ      R12, 1, 1
	BRA         L_tosh_163
;IRTx.c,273 :: 		}
L_end_tosh_1:
	RETURN      0
; end of _tosh_1

_tosh_bit:

;IRTx.c,276 :: 		void tosh_bit(char tosh_bitval){
;IRTx.c,278 :: 		if(tosh_bitval & 1){
	BTFSS       FARG_tosh_bit_tosh_bitval+0, 0 
	GOTO        L_tosh_bit64
;IRTx.c,279 :: 		tosh_1();
	CALL        _tosh_1+0, 0
;IRTx.c,280 :: 		}
	GOTO        L_tosh_bit65
L_tosh_bit64:
;IRTx.c,282 :: 		tosh_0();
	CALL        _tosh_0+0, 0
;IRTx.c,283 :: 		}
L_tosh_bit65:
;IRTx.c,284 :: 		}
L_end_tosh_bit:
	RETURN      0
; end of _tosh_bit

_rc5_0:

;IRTx.c,288 :: 		void rc5_0(void){
;IRTx.c,289 :: 		PWM1_Start();                        // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,290 :: 		Delay_us(889);
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_rc5_066:
	DECFSZ      R13, 1, 1
	BRA         L_rc5_066
	DECFSZ      R12, 1, 1
	BRA         L_rc5_066
;IRTx.c,291 :: 		PWM1_Stop();                         // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,292 :: 		Delay_us(889);
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_rc5_067:
	DECFSZ      R13, 1, 1
	BRA         L_rc5_067
	DECFSZ      R12, 1, 1
	BRA         L_rc5_067
;IRTx.c,293 :: 		}
L_end_rc5_0:
	RETURN      0
; end of _rc5_0

_rc5_1:

;IRTx.c,296 :: 		void rc5_1(void){
;IRTx.c,297 :: 		PWM1_Stop();                         // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,298 :: 		Delay_us(889);
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_rc5_168:
	DECFSZ      R13, 1, 1
	BRA         L_rc5_168
	DECFSZ      R12, 1, 1
	BRA         L_rc5_168
;IRTx.c,299 :: 		PWM1_Start();                        // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,300 :: 		Delay_us(889);
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_rc5_169:
	DECFSZ      R13, 1, 1
	BRA         L_rc5_169
	DECFSZ      R12, 1, 1
	BRA         L_rc5_169
;IRTx.c,301 :: 		}
L_end_rc5_1:
	RETURN      0
; end of _rc5_1

_ir_rc5_bit:

;IRTx.c,304 :: 		void ir_rc5_bit(char rc5_bitval){
;IRTx.c,306 :: 		if(rc5_bitval & 1){
	BTFSS       FARG_ir_rc5_bit_rc5_bitval+0, 0 
	GOTO        L_ir_rc5_bit70
;IRTx.c,307 :: 		rc5_1();
	CALL        _rc5_1+0, 0
;IRTx.c,308 :: 		}
	GOTO        L_ir_rc5_bit71
L_ir_rc5_bit70:
;IRTx.c,310 :: 		rc5_0();
	CALL        _rc5_0+0, 0
;IRTx.c,311 :: 		}
L_ir_rc5_bit71:
;IRTx.c,312 :: 		}
L_end_ir_rc5_bit:
	RETURN      0
; end of _ir_rc5_bit

_rc6_double_bit:

;IRTx.c,315 :: 		void rc6_double_bit(char bitval){
;IRTx.c,317 :: 		if(bitval & 1){
	BTFSS       FARG_rc6_double_bit_bitval+0, 0 
	GOTO        L_rc6_double_bit72
;IRTx.c,318 :: 		rc6_double_1();
	CALL        _rc6_double_1+0, 0
;IRTx.c,319 :: 		}
	GOTO        L_rc6_double_bit73
L_rc6_double_bit72:
;IRTx.c,321 :: 		rc6_double_0();
	CALL        _rc6_double_0+0, 0
;IRTx.c,322 :: 		}
L_rc6_double_bit73:
;IRTx.c,323 :: 		}
L_end_rc6_double_bit:
	RETURN      0
; end of _rc6_double_bit

_rc6_double_1:

;IRTx.c,326 :: 		void rc6_double_1(void){
;IRTx.c,327 :: 		PWM1_Start();                        // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,328 :: 		Delay_us(889);
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_rc6_double_174:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_double_174
	DECFSZ      R12, 1, 1
	BRA         L_rc6_double_174
;IRTx.c,329 :: 		PWM1_Stop();                         // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,330 :: 		Delay_us(889);
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_rc6_double_175:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_double_175
	DECFSZ      R12, 1, 1
	BRA         L_rc6_double_175
;IRTx.c,331 :: 		}
L_end_rc6_double_1:
	RETURN      0
; end of _rc6_double_1

_rc6_double_0:

;IRTx.c,334 :: 		void rc6_double_0(void){
;IRTx.c,335 :: 		PWM1_Stop();                         // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,336 :: 		Delay_us(889);
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_rc6_double_076:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_double_076
	DECFSZ      R12, 1, 1
	BRA         L_rc6_double_076
;IRTx.c,337 :: 		PWM1_Start();                        // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,338 :: 		Delay_us(889);
	MOVLW       10
	MOVWF       R12, 0
	MOVLW       59
	MOVWF       R13, 0
L_rc6_double_077:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_double_077
	DECFSZ      R12, 1, 1
	BRA         L_rc6_double_077
;IRTx.c,339 :: 		}
L_end_rc6_double_0:
	RETURN      0
; end of _rc6_double_0

_rc6_1:

;IRTx.c,342 :: 		void rc6_1(void){
;IRTx.c,343 :: 		PWM1_Start();                        // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,344 :: 		Delay_us(444);
	MOVLW       5
	MOVWF       R12, 0
	MOVLW       155
	MOVWF       R13, 0
L_rc6_178:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_178
	DECFSZ      R12, 1, 1
	BRA         L_rc6_178
	NOP
	NOP
;IRTx.c,345 :: 		PWM1_Stop();                         // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,346 :: 		Delay_us(444);
	MOVLW       5
	MOVWF       R12, 0
	MOVLW       155
	MOVWF       R13, 0
L_rc6_179:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_179
	DECFSZ      R12, 1, 1
	BRA         L_rc6_179
	NOP
	NOP
;IRTx.c,347 :: 		}
L_end_rc6_1:
	RETURN      0
; end of _rc6_1

_rc6_0:

;IRTx.c,350 :: 		void rc6_0(void){
;IRTx.c,351 :: 		PWM1_Stop();                         // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,352 :: 		Delay_us(444);
	MOVLW       5
	MOVWF       R12, 0
	MOVLW       155
	MOVWF       R13, 0
L_rc6_080:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_080
	DECFSZ      R12, 1, 1
	BRA         L_rc6_080
	NOP
	NOP
;IRTx.c,353 :: 		PWM1_Start();                        // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,354 :: 		Delay_us(444);
	MOVLW       5
	MOVWF       R12, 0
	MOVLW       155
	MOVWF       R13, 0
L_rc6_081:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_081
	DECFSZ      R12, 1, 1
	BRA         L_rc6_081
	NOP
	NOP
;IRTx.c,355 :: 		}
L_end_rc6_0:
	RETURN      0
; end of _rc6_0

_ir_rc6_bit:

;IRTx.c,358 :: 		void ir_rc6_bit(char rc6_bitval){
;IRTx.c,360 :: 		if(rc6_bitval & 1){
	BTFSS       FARG_ir_rc6_bit_rc6_bitval+0, 0 
	GOTO        L_ir_rc6_bit82
;IRTx.c,361 :: 		rc6_1();
	CALL        _rc6_1+0, 0
;IRTx.c,362 :: 		}
	GOTO        L_ir_rc6_bit83
L_ir_rc6_bit82:
;IRTx.c,364 :: 		rc6_0();
	CALL        _rc6_0+0, 0
;IRTx.c,365 :: 		}
L_ir_rc6_bit83:
;IRTx.c,366 :: 		}
L_end_ir_rc6_bit:
	RETURN      0
; end of _ir_rc6_bit

_send_nec:

;IRTx.c,370 :: 		void send_nec(void){
;IRTx.c,374 :: 		set_38();                                       // 38 KHz IR
	CALL        _set_38+0, 0
;IRTx.c,375 :: 		ir_byte[4] = ~ir_byte[3];                       // byte 4 is inverse of byte 3
	COMF        _ir_byte+3, 0 
	MOVWF       _ir_byte+4 
;IRTx.c,376 :: 		Delay_ms(100);                                  // precaution to be certain of some dead time before message start
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_nec84:
	DECFSZ      R13, 1, 1
	BRA         L_send_nec84
	DECFSZ      R12, 1, 1
	BRA         L_send_nec84
	DECFSZ      R11, 1, 1
	BRA         L_send_nec84
;IRTx.c,377 :: 		PWM1_Start();                                   // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,378 :: 		Delay_us(9000);                                 // 9mS mark start bit
	MOVLW       94
	MOVWF       R12, 0
	MOVLW       128
	MOVWF       R13, 0
L_send_nec85:
	DECFSZ      R13, 1, 1
	BRA         L_send_nec85
	DECFSZ      R12, 1, 1
	BRA         L_send_nec85
	NOP
;IRTx.c,379 :: 		PWM1_Stop();                                    // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,380 :: 		Delay_us(4500);                                 // 4.5mS space ends start bit
	MOVLW       47
	MOVWF       R12, 0
	MOVLW       191
	MOVWF       R13, 0
L_send_nec86:
	DECFSZ      R13, 1, 1
	BRA         L_send_nec86
	DECFSZ      R12, 1, 1
	BRA         L_send_nec86
	NOP
	NOP
;IRTx.c,381 :: 		for(bytenum = 1; bytenum < 5; bytenum++){       // 4 bytes to send
	MOVLW       1
	MOVWF       send_nec_bytenum_L0+0 
L_send_nec87:
	MOVLW       5
	SUBWF       send_nec_bytenum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_nec88
;IRTx.c,382 :: 		for(bitnum = 0; bitnum < 8; bitnum++){      // 8 bits LSB first
	CLRF        send_nec_bitnum_L0+0 
L_send_nec90:
	MOVLW       8
	SUBWF       send_nec_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_nec91
;IRTx.c,383 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,384 :: 		Delay_us(560);                          // 560uS mark for '0' or '1'
	MOVLW       6
	MOVWF       R12, 0
	MOVLW       208
	MOVWF       R13, 0
L_send_nec93:
	DECFSZ      R13, 1, 1
	BRA         L_send_nec93
	DECFSZ      R12, 1, 1
	BRA         L_send_nec93
	NOP
;IRTx.c,385 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,386 :: 		if(ir_byte[bytenum] & (1 << bitnum)){   // test bit <bitnum>
	MOVLW       _ir_byte+0
	MOVWF       FSR0 
	MOVLW       hi_addr(_ir_byte+0)
	MOVWF       FSR0H 
	MOVF        send_nec_bytenum_L0+0, 0 
	ADDWF       FSR0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        send_nec_bitnum_L0+0, 0 
	MOVWF       R2 
	MOVLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__send_nec211:
	BZ          L__send_nec212
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__send_nec211
L__send_nec212:
	MOVF        POSTINC0+0, 0 
	ANDWF       R0, 1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_send_nec94
;IRTx.c,387 :: 		Delay_us(1680);                     // 1.68mS space for a '1'
	MOVLW       18
	MOVWF       R12, 0
	MOVLW       115
	MOVWF       R13, 0
L_send_nec95:
	DECFSZ      R13, 1, 1
	BRA         L_send_nec95
	DECFSZ      R12, 1, 1
	BRA         L_send_nec95
;IRTx.c,388 :: 		}
	GOTO        L_send_nec96
L_send_nec94:
;IRTx.c,390 :: 		Delay_us(560);                      // 560uS space for a '0'
	MOVLW       6
	MOVWF       R12, 0
	MOVLW       208
	MOVWF       R13, 0
L_send_nec97:
	DECFSZ      R13, 1, 1
	BRA         L_send_nec97
	DECFSZ      R12, 1, 1
	BRA         L_send_nec97
	NOP
;IRTx.c,391 :: 		}
L_send_nec96:
;IRTx.c,382 :: 		for(bitnum = 0; bitnum < 8; bitnum++){      // 8 bits LSB first
	INCF        send_nec_bitnum_L0+0, 1 
;IRTx.c,394 :: 		}
	GOTO        L_send_nec90
L_send_nec91:
;IRTx.c,381 :: 		for(bytenum = 1; bytenum < 5; bytenum++){       // 4 bytes to send
	INCF        send_nec_bytenum_L0+0, 1 
;IRTx.c,395 :: 		}
	GOTO        L_send_nec87
L_send_nec88:
;IRTx.c,396 :: 		PWM1_Start();                                   // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,397 :: 		Delay_us(560);                                  // stop bit of '1'
	MOVLW       6
	MOVWF       R12, 0
	MOVLW       208
	MOVWF       R13, 0
L_send_nec98:
	DECFSZ      R13, 1, 1
	BRA         L_send_nec98
	DECFSZ      R12, 1, 1
	BRA         L_send_nec98
	NOP
;IRTx.c,398 :: 		PWM1_Stop();                                    // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,399 :: 		Delay_us(1680);                                 // stop bit of 1
	MOVLW       18
	MOVWF       R12, 0
	MOVLW       115
	MOVWF       R13, 0
L_send_nec99:
	DECFSZ      R13, 1, 1
	BRA         L_send_nec99
	DECFSZ      R12, 1, 1
	BRA         L_send_nec99
;IRTx.c,400 :: 		Delay_ms(100);                                  // precaution to be certain of some dead time after message ends
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_send_nec100:
	DECFSZ      R13, 1, 1
	BRA         L_send_nec100
	DECFSZ      R12, 1, 1
	BRA         L_send_nec100
	DECFSZ      R11, 1, 1
	BRA         L_send_nec100
;IRTx.c,401 :: 		}
L_end_send_nec:
	RETURN      0
; end of _send_nec

_send_sony:

;IRTx.c,412 :: 		void send_sony(void){
;IRTx.c,415 :: 		set_40();                                   // 40 KHz IR
	CALL        _set_40+0, 0
;IRTx.c,416 :: 		PWM1_Start();                               // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,417 :: 		Delay_us(2400);                             // 2.4mS mark start bit
	MOVLW       25
	MOVWF       R12, 0
	MOVLW       238
	MOVWF       R13, 0
L_send_sony101:
	DECFSZ      R13, 1, 1
	BRA         L_send_sony101
	DECFSZ      R12, 1, 1
	BRA         L_send_sony101
	NOP
;IRTx.c,418 :: 		PWM1_Stop();                                // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,419 :: 		Delay_us(600);                              // 600uS space ends start bit
	MOVLW       7
	MOVWF       R12, 0
	MOVLW       58
	MOVWF       R13, 0
L_send_sony102:
	DECFSZ      R13, 1, 1
	BRA         L_send_sony102
	DECFSZ      R12, 1, 1
	BRA         L_send_sony102
	NOP
;IRTx.c,420 :: 		for(bitnum = 0; bitnum < 7; bitnum++){      // 7 bit command LSB first
	CLRF        send_sony_bitnum_L0+0 
L_send_sony103:
	MOVLW       7
	SUBWF       send_sony_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_sony104
;IRTx.c,421 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,422 :: 		if(ir_byte[1] & (1 << bitnum)){         // test bit <bitnum>
	MOVF        send_sony_bitnum_L0+0, 0 
	MOVWF       R2 
	MOVLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__send_sony214:
	BZ          L__send_sony215
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__send_sony214
L__send_sony215:
	MOVF        _ir_byte+1, 0 
	ANDWF       R0, 1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_send_sony106
;IRTx.c,423 :: 		Delay_us(1200);                     // 1.2mS mark for a '1'
	MOVLW       13
	MOVWF       R12, 0
	MOVLW       118
	MOVWF       R13, 0
L_send_sony107:
	DECFSZ      R13, 1, 1
	BRA         L_send_sony107
	DECFSZ      R12, 1, 1
	BRA         L_send_sony107
	NOP
;IRTx.c,424 :: 		}
	GOTO        L_send_sony108
L_send_sony106:
;IRTx.c,426 :: 		Delay_us(600);                      // 600uS mark for a '0'
	MOVLW       7
	MOVWF       R12, 0
	MOVLW       58
	MOVWF       R13, 0
L_send_sony109:
	DECFSZ      R13, 1, 1
	BRA         L_send_sony109
	DECFSZ      R12, 1, 1
	BRA         L_send_sony109
	NOP
;IRTx.c,427 :: 		}
L_send_sony108:
;IRTx.c,428 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,429 :: 		Delay_us(600);                          // 600uS space for '0' or '1'
	MOVLW       7
	MOVWF       R12, 0
	MOVLW       58
	MOVWF       R13, 0
L_send_sony110:
	DECFSZ      R13, 1, 1
	BRA         L_send_sony110
	DECFSZ      R12, 1, 1
	BRA         L_send_sony110
	NOP
;IRTx.c,420 :: 		for(bitnum = 0; bitnum < 7; bitnum++){      // 7 bit command LSB first
	INCF        send_sony_bitnum_L0+0, 1 
;IRTx.c,430 :: 		}
	GOTO        L_send_sony103
L_send_sony104:
;IRTx.c,431 :: 		for(bitnum = 0; bitnum < 5; bitnum++){      // 5 bit address LSB first
	CLRF        send_sony_bitnum_L0+0 
L_send_sony111:
	MOVLW       5
	SUBWF       send_sony_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_sony112
;IRTx.c,432 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,433 :: 		if(ir_byte[2] & (1 << bitnum)){        // test bit <bitnum>
	MOVF        send_sony_bitnum_L0+0, 0 
	MOVWF       R2 
	MOVLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__send_sony216:
	BZ          L__send_sony217
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__send_sony216
L__send_sony217:
	MOVF        _ir_byte+2, 0 
	ANDWF       R0, 1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_send_sony114
;IRTx.c,434 :: 		Delay_us(1200);                     // 1.2mS mark for a '1'
	MOVLW       13
	MOVWF       R12, 0
	MOVLW       118
	MOVWF       R13, 0
L_send_sony115:
	DECFSZ      R13, 1, 1
	BRA         L_send_sony115
	DECFSZ      R12, 1, 1
	BRA         L_send_sony115
	NOP
;IRTx.c,435 :: 		}
	GOTO        L_send_sony116
L_send_sony114:
;IRTx.c,437 :: 		Delay_us(600);                      // 600uS mark for a '0'
	MOVLW       7
	MOVWF       R12, 0
	MOVLW       58
	MOVWF       R13, 0
L_send_sony117:
	DECFSZ      R13, 1, 1
	BRA         L_send_sony117
	DECFSZ      R12, 1, 1
	BRA         L_send_sony117
	NOP
;IRTx.c,438 :: 		}
L_send_sony116:
;IRTx.c,439 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,440 :: 		Delay_us(600);                          // 600uS space for '0' or '1'
	MOVLW       7
	MOVWF       R12, 0
	MOVLW       58
	MOVWF       R13, 0
L_send_sony118:
	DECFSZ      R13, 1, 1
	BRA         L_send_sony118
	DECFSZ      R12, 1, 1
	BRA         L_send_sony118
	NOP
;IRTx.c,431 :: 		for(bitnum = 0; bitnum < 5; bitnum++){      // 5 bit address LSB first
	INCF        send_sony_bitnum_L0+0, 1 
;IRTx.c,441 :: 		}
	GOTO        L_send_sony111
L_send_sony112:
;IRTx.c,442 :: 		Delay_ms(26);                               // 26 millisecond inter-message gap
	MOVLW       2
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       29
	MOVWF       R13, 0
L_send_sony119:
	DECFSZ      R13, 1, 1
	BRA         L_send_sony119
	DECFSZ      R12, 1, 1
	BRA         L_send_sony119
	DECFSZ      R11, 1, 1
	BRA         L_send_sony119
	NOP
	NOP
;IRTx.c,443 :: 		}
L_end_send_sony:
	RETURN      0
; end of _send_sony

_send_sharp:

;IRTx.c,446 :: 		void send_sharp(void){
;IRTx.c,449 :: 		set_38();                                   // 38 KHz IR
	CALL        _set_38+0, 0
;IRTx.c,450 :: 		for(bitnum = 0; bitnum < 5; bitnum++){      // 5 bit address LSB first
	CLRF        send_sharp_bitnum_L0+0 
L_send_sharp120:
	MOVLW       5
	SUBWF       send_sharp_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_sharp121
;IRTx.c,451 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,452 :: 		Delay_us(320);                          // 320uS mark
	MOVLW       4
	MOVWF       R12, 0
	MOVLW       81
	MOVWF       R13, 0
L_send_sharp123:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp123
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp123
	NOP
	NOP
;IRTx.c,453 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,454 :: 		if(ir_byte[1] & (1 << bitnum)){         // test bit <bitnum>
	MOVF        send_sharp_bitnum_L0+0, 0 
	MOVWF       R2 
	MOVLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__send_sharp219:
	BZ          L__send_sharp220
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__send_sharp219
L__send_sharp220:
	MOVF        _ir_byte+1, 0 
	ANDWF       R0, 1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_send_sharp124
;IRTx.c,455 :: 		Delay_us(1680);                     // 1680uS space for a '1'
	MOVLW       18
	MOVWF       R12, 0
	MOVLW       115
	MOVWF       R13, 0
L_send_sharp125:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp125
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp125
;IRTx.c,456 :: 		}
	GOTO        L_send_sharp126
L_send_sharp124:
;IRTx.c,458 :: 		Delay_us(680);                      // 680uS space for a '0'
	MOVLW       8
	MOVWF       R12, 0
	MOVLW       15
	MOVWF       R13, 0
L_send_sharp127:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp127
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp127
;IRTx.c,459 :: 		}
L_send_sharp126:
;IRTx.c,450 :: 		for(bitnum = 0; bitnum < 5; bitnum++){      // 5 bit address LSB first
	INCF        send_sharp_bitnum_L0+0, 1 
;IRTx.c,460 :: 		}
	GOTO        L_send_sharp120
L_send_sharp121:
;IRTx.c,461 :: 		for(bitnum = 0; bitnum < 8; bitnum++){      // 8 bit command LSB first
	CLRF        send_sharp_bitnum_L0+0 
L_send_sharp128:
	MOVLW       8
	SUBWF       send_sharp_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_sharp129
;IRTx.c,462 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,463 :: 		Delay_us(320);                          // 320uS mark
	MOVLW       4
	MOVWF       R12, 0
	MOVLW       81
	MOVWF       R13, 0
L_send_sharp131:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp131
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp131
	NOP
	NOP
;IRTx.c,464 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,465 :: 		if(ir_byte[2] & (1 << bitnum)){         // test bit <bitnum>
	MOVF        send_sharp_bitnum_L0+0, 0 
	MOVWF       R2 
	MOVLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__send_sharp221:
	BZ          L__send_sharp222
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__send_sharp221
L__send_sharp222:
	MOVF        _ir_byte+2, 0 
	ANDWF       R0, 1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_send_sharp132
;IRTx.c,466 :: 		Delay_us(1680);                     // 1680uS space for a '1'
	MOVLW       18
	MOVWF       R12, 0
	MOVLW       115
	MOVWF       R13, 0
L_send_sharp133:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp133
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp133
;IRTx.c,467 :: 		}
	GOTO        L_send_sharp134
L_send_sharp132:
;IRTx.c,469 :: 		Delay_us(680);                      // 680uS space for a '0'
	MOVLW       8
	MOVWF       R12, 0
	MOVLW       15
	MOVWF       R13, 0
L_send_sharp135:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp135
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp135
;IRTx.c,470 :: 		}
L_send_sharp134:
;IRTx.c,461 :: 		for(bitnum = 0; bitnum < 8; bitnum++){      // 8 bit command LSB first
	INCF        send_sharp_bitnum_L0+0, 1 
;IRTx.c,471 :: 		}
	GOTO        L_send_sharp128
L_send_sharp129:
;IRTx.c,474 :: 		for(bitnum = 0; bitnum < 2; bitnum++){      // 2 bit extension LSB first
	CLRF        send_sharp_bitnum_L0+0 
L_send_sharp136:
	MOVLW       2
	SUBWF       send_sharp_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_sharp137
;IRTx.c,475 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,476 :: 		Delay_us(320);                          // 320uS mark
	MOVLW       4
	MOVWF       R12, 0
	MOVLW       81
	MOVWF       R13, 0
L_send_sharp139:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp139
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp139
	NOP
	NOP
;IRTx.c,477 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,478 :: 		Delay_us(1680);                         // 1680uS space for a '1'
	MOVLW       18
	MOVWF       R12, 0
	MOVLW       115
	MOVWF       R13, 0
L_send_sharp140:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp140
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp140
;IRTx.c,479 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,480 :: 		Delay_us(680);                          // 680uS space for a '0'
	MOVLW       8
	MOVWF       R12, 0
	MOVLW       15
	MOVWF       R13, 0
L_send_sharp141:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp141
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp141
;IRTx.c,481 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,474 :: 		for(bitnum = 0; bitnum < 2; bitnum++){      // 2 bit extension LSB first
	INCF        send_sharp_bitnum_L0+0, 1 
;IRTx.c,482 :: 		}
	GOTO        L_send_sharp136
L_send_sharp137:
;IRTx.c,485 :: 		PWM1_Start();                               // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,486 :: 		Delay_us(320);                              // 320uS mark
	MOVLW       4
	MOVWF       R12, 0
	MOVLW       81
	MOVWF       R13, 0
L_send_sharp142:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp142
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp142
	NOP
	NOP
;IRTx.c,487 :: 		PWM1_Stop();                                // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,488 :: 		Delay_ms(40);                               // 40 millisecond inter-message gap
	MOVLW       2
	MOVWF       R11, 0
	MOVLW       160
	MOVWF       R12, 0
	MOVLW       146
	MOVWF       R13, 0
L_send_sharp143:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp143
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp143
	DECFSZ      R11, 1, 1
	BRA         L_send_sharp143
	NOP
;IRTx.c,491 :: 		for(bitnum = 0; bitnum < 5; bitnum++){      // 5 bit address LSB first
	CLRF        send_sharp_bitnum_L0+0 
L_send_sharp144:
	MOVLW       5
	SUBWF       send_sharp_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_sharp145
;IRTx.c,492 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,493 :: 		Delay_us(320);                          // 320uS mark
	MOVLW       4
	MOVWF       R12, 0
	MOVLW       81
	MOVWF       R13, 0
L_send_sharp147:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp147
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp147
	NOP
	NOP
;IRTx.c,494 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,495 :: 		if(ir_byte[1] & (1 << bitnum)){         // test bit <bitnum>
	MOVF        send_sharp_bitnum_L0+0, 0 
	MOVWF       R2 
	MOVLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__send_sharp223:
	BZ          L__send_sharp224
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__send_sharp223
L__send_sharp224:
	MOVF        _ir_byte+1, 0 
	ANDWF       R0, 1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_send_sharp148
;IRTx.c,496 :: 		Delay_us(1680);                     // 1680uS space for a '1'
	MOVLW       18
	MOVWF       R12, 0
	MOVLW       115
	MOVWF       R13, 0
L_send_sharp149:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp149
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp149
;IRTx.c,497 :: 		}
	GOTO        L_send_sharp150
L_send_sharp148:
;IRTx.c,499 :: 		Delay_us(680);                      // 680uS space for a '0'
	MOVLW       8
	MOVWF       R12, 0
	MOVLW       15
	MOVWF       R13, 0
L_send_sharp151:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp151
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp151
;IRTx.c,500 :: 		}
L_send_sharp150:
;IRTx.c,491 :: 		for(bitnum = 0; bitnum < 5; bitnum++){      // 5 bit address LSB first
	INCF        send_sharp_bitnum_L0+0, 1 
;IRTx.c,501 :: 		}
	GOTO        L_send_sharp144
L_send_sharp145:
;IRTx.c,504 :: 		for(bitnum = 0; bitnum < 8; bitnum++){      // 8 bit command LSB first
	CLRF        send_sharp_bitnum_L0+0 
L_send_sharp152:
	MOVLW       8
	SUBWF       send_sharp_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_sharp153
;IRTx.c,505 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,506 :: 		Delay_us(320);                          // 320uS mark
	MOVLW       4
	MOVWF       R12, 0
	MOVLW       81
	MOVWF       R13, 0
L_send_sharp155:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp155
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp155
	NOP
	NOP
;IRTx.c,507 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,508 :: 		if(ir_byte[2] & (1 << bitnum)){         // test bit <bitnum>
	MOVF        send_sharp_bitnum_L0+0, 0 
	MOVWF       R2 
	MOVLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__send_sharp225:
	BZ          L__send_sharp226
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__send_sharp225
L__send_sharp226:
	MOVF        _ir_byte+2, 0 
	ANDWF       R0, 1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_send_sharp156
;IRTx.c,509 :: 		Delay_us(680);                      // 680uS space for an INVERTED '1'
	MOVLW       8
	MOVWF       R12, 0
	MOVLW       15
	MOVWF       R13, 0
L_send_sharp157:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp157
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp157
;IRTx.c,510 :: 		}
	GOTO        L_send_sharp158
L_send_sharp156:
;IRTx.c,512 :: 		Delay_us(1680);                     // 1680uS space for an INVERTED '0'
	MOVLW       18
	MOVWF       R12, 0
	MOVLW       115
	MOVWF       R13, 0
L_send_sharp159:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp159
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp159
;IRTx.c,513 :: 		}
L_send_sharp158:
;IRTx.c,504 :: 		for(bitnum = 0; bitnum < 8; bitnum++){      // 8 bit command LSB first
	INCF        send_sharp_bitnum_L0+0, 1 
;IRTx.c,514 :: 		}
	GOTO        L_send_sharp152
L_send_sharp153:
;IRTx.c,517 :: 		for(bitnum = 0; bitnum < 2; bitnum++){      // 2 bit extension LSB first
	CLRF        send_sharp_bitnum_L0+0 
L_send_sharp160:
	MOVLW       2
	SUBWF       send_sharp_bitnum_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_send_sharp161
;IRTx.c,518 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,519 :: 		Delay_us(320);                          // 320uS mark
	MOVLW       4
	MOVWF       R12, 0
	MOVLW       81
	MOVWF       R13, 0
L_send_sharp163:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp163
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp163
	NOP
	NOP
;IRTx.c,520 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,521 :: 		Delay_us(680);                          // 1680uS space for an INVERTED '1'
	MOVLW       8
	MOVWF       R12, 0
	MOVLW       15
	MOVWF       R13, 0
L_send_sharp164:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp164
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp164
;IRTx.c,522 :: 		PWM1_Start();                           // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,523 :: 		Delay_us(1680);                         // 680uS space for an INVERTED '0'
	MOVLW       18
	MOVWF       R12, 0
	MOVLW       115
	MOVWF       R13, 0
L_send_sharp165:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp165
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp165
;IRTx.c,524 :: 		PWM1_Stop();                            // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,517 :: 		for(bitnum = 0; bitnum < 2; bitnum++){      // 2 bit extension LSB first
	INCF        send_sharp_bitnum_L0+0, 1 
;IRTx.c,525 :: 		}
	GOTO        L_send_sharp160
L_send_sharp161:
;IRTx.c,528 :: 		PWM1_Start();                               // mark
	CALL        _PWM1_Start+0, 0
;IRTx.c,529 :: 		Delay_us(320);                              // 320uS mark
	MOVLW       4
	MOVWF       R12, 0
	MOVLW       81
	MOVWF       R13, 0
L_send_sharp166:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp166
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp166
	NOP
	NOP
;IRTx.c,530 :: 		PWM1_Stop();                                // space
	CALL        _PWM1_Stop+0, 0
;IRTx.c,531 :: 		Delay_ms(40);                               // 40 millisecond inter-message gap
	MOVLW       2
	MOVWF       R11, 0
	MOVLW       160
	MOVWF       R12, 0
	MOVLW       146
	MOVWF       R13, 0
L_send_sharp167:
	DECFSZ      R13, 1, 1
	BRA         L_send_sharp167
	DECFSZ      R12, 1, 1
	BRA         L_send_sharp167
	DECFSZ      R11, 1, 1
	BRA         L_send_sharp167
	NOP
;IRTx.c,532 :: 		}
L_end_send_sharp:
	RETURN      0
; end of _send_sharp
