#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRtx683Sony/IRtx683sony.c"
#line 13 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRtx683Sony/IRtx683sony.c"
void pwm_start(void);
void pwm_stop(void);
void send_1(void);
void send_0(void);

void main() {
unsigned char sony_address;
unsigned char sony_command;
char n;

 OSCCON = 0x71;

 ADCON0 = 0;
 ANSEL = 0;
 CMCON0 = 7;
 GPIO = 0;
 TRISIO = 0xfb;
 WPU = 0x33;
 OPTION_REG.B7 = 0;

 T2CON = 0x04;
 PR2 = 0x31;
 CCPR1L = 0x17;
 CCP1CON = 0x30;

 while (1){
 if((GPIO & 0x33) != 0x33){
 sony_address = 0;
 sony_command = 0;
 if (!GPIO.B0){
 sony_address = 1;
 sony_command = 0;
 }
 if (!GPIO.B1){
 sony_address = 1;
 sony_command = 1;
 }
 if (!GPIO.B4){
 sony_address = 1;
 sony_command = 2;
 }
 if (!GPIO.B5){
 sony_address = 1;
 sony_command = 3;
 }
 pwm_start();
 Delay_us(2400);
 pwm_stop();
 Delay_us(1200);
 for(n=0; n<7 ; n++){
 if(sony_command & (1<<n)){
 send_1();
 }
 else{
 send_0();
 }
 }
 for(n=0; n<5 ; n++){
 if(sony_address & (1<<n)){
 send_1();
 }
 else{
 send_0();
 }
 }
 pwm_stop();
 Delay_ms(300);
 }
 }
}


void send_0(void){
 pwm_start();
 Delay_us(600);
 pwm_stop();
 Delay_us(600);
}


void send_1(void){
 pwm_start();
 Delay_us(1200);
 pwm_stop();
 Delay_us(600);
}



void pwm_start(void){
 CCP1CON = 0x3c;
}


void pwm_stop(void){
 CCP1CON = 0x30;
}
