
_main:

;IRtx683er4.c,19 :: 		void main() {
;IRtx683er4.c,22 :: 		OSCCON = 0x71;                      // Internal 8MHz osc.
	MOVLW      113
	MOVWF      OSCCON+0
;IRtx683er4.c,24 :: 		ADCON0 = 0;                         // all pins digital
	CLRF       ADCON0+0
;IRtx683er4.c,25 :: 		ANSEL = 0;                          // all pins digital
	CLRF       ANSEL+0
;IRtx683er4.c,26 :: 		CMCON0 = 7;                         // Comparators off.
	MOVLW      7
	MOVWF      CMCON0+0
;IRtx683er4.c,27 :: 		GPIO = 0;                           // all pins low
	CLRF       GPIO+0
;IRtx683er4.c,28 :: 		TRISIO = 0xfb;                      // all input, bar GP2
	MOVLW      251
	MOVWF      TRISIO+0
;IRtx683er4.c,29 :: 		WPU = 0x33;                         // weak pull-ups on button inputs
	MOVLW      51
	MOVWF      WPU+0
;IRtx683er4.c,30 :: 		OPTION_REG.B7 = 0;                  // ~GPPU bit is cleared to enable weak pull-ups
	BCF        OPTION_REG+0, 7
;IRtx683er4.c,32 :: 		T2CON = 0x04;                       // prescaler + turn on TMR2;
	MOVLW      4
	MOVWF      T2CON+0
;IRtx683er4.c,33 :: 		PR2 = 0x33;                         // freq 0x33 for 38kHz
	MOVLW      51
	MOVWF      PR2+0
;IRtx683er4.c,34 :: 		CCPR1L = 0x18;                      // set low time 0x18 for 38kHz
	MOVLW      24
	MOVWF      CCPR1L+0
;IRtx683er4.c,35 :: 		CCP1CON = 0x30;                     // duty lowest bits + PWM mode (PWM off)
	MOVLW      48
	MOVWF      CCP1CON+0
;IRtx683er4.c,37 :: 		while (1){
L_main0:
;IRtx683er4.c,38 :: 		if((GPIO & 0x33) != 0x33){          // wait for switch to go low
	MOVLW      51
	ANDWF      GPIO+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      51
	BTFSC      STATUS+0, 2
	GOTO       L_main2
;IRtx683er4.c,39 :: 		if (!GPIO.B0){                  // PIC button 1
	BTFSC      GPIO+0, 0
	GOTO       L_main3
;IRtx683er4.c,40 :: 		chout('A');                 // send serial
	MOVLW      65
	MOVWF      FARG_chout_ch_to_send+0
	CALL       _chout+0
;IRtx683er4.c,41 :: 		chout('a');                 // send serial
	MOVLW      97
	MOVWF      FARG_chout_ch_to_send+0
	CALL       _chout+0
;IRtx683er4.c,42 :: 		}
L_main3:
;IRtx683er4.c,43 :: 		if (!GPIO.B1){                  // PIC button 2
	BTFSC      GPIO+0, 1
	GOTO       L_main4
;IRtx683er4.c,44 :: 		chout('B');                 // send serial
	MOVLW      66
	MOVWF      FARG_chout_ch_to_send+0
	CALL       _chout+0
;IRtx683er4.c,45 :: 		chout('b');                 // send serial
	MOVLW      98
	MOVWF      FARG_chout_ch_to_send+0
	CALL       _chout+0
;IRtx683er4.c,46 :: 		}
L_main4:
;IRtx683er4.c,47 :: 		if (!GPIO.B4){                  // PIC button 3
	BTFSC      GPIO+0, 4
	GOTO       L_main5
;IRtx683er4.c,48 :: 		chout('C');                 // send serial
	MOVLW      67
	MOVWF      FARG_chout_ch_to_send+0
	CALL       _chout+0
;IRtx683er4.c,49 :: 		chout('c');                 // send serial
	MOVLW      99
	MOVWF      FARG_chout_ch_to_send+0
	CALL       _chout+0
;IRtx683er4.c,50 :: 		}
L_main5:
;IRtx683er4.c,51 :: 		if (!GPIO.B5){                  // PIC button 4
	BTFSC      GPIO+0, 5
	GOTO       L_main6
;IRtx683er4.c,52 :: 		chout('D');                 // send serial
	MOVLW      68
	MOVWF      FARG_chout_ch_to_send+0
	CALL       _chout+0
;IRtx683er4.c,53 :: 		chout('d');                 // send serial
	MOVLW      100
	MOVWF      FARG_chout_ch_to_send+0
	CALL       _chout+0
;IRtx683er4.c,54 :: 		}
L_main6:
;IRtx683er4.c,55 :: 		pwm_stop();                     // allow gap between messages
	CALL       _pwm_stop+0
;IRtx683er4.c,56 :: 		Delay_ms(300);                  // limit message rate with suitable message free time
	MOVLW      4
	MOVWF      R11+0
	MOVLW      12
	MOVWF      R12+0
	MOVLW      51
	MOVWF      R13+0
L_main7:
	DECFSZ     R13+0, 1
	GOTO       L_main7
	DECFSZ     R12+0, 1
	GOTO       L_main7
	DECFSZ     R11+0, 1
	GOTO       L_main7
	NOP
	NOP
;IRtx683er4.c,57 :: 		}
L_main2:
;IRtx683er4.c,58 :: 		}
	GOTO       L_main0
;IRtx683er4.c,59 :: 		}
L_end_main:
	GOTO       $+0
; end of _main

_chout:

;IRtx683er4.c,62 :: 		void chout(unsigned char ch_to_send){
;IRtx683er4.c,66 :: 		temp_char = ch_to_send;
	MOVF       FARG_chout_ch_to_send+0, 0
	MOVWF      chout_temp_char_L0+0
;IRtx683er4.c,67 :: 		send_0();                          // start bit
	CALL       _send_0+0
;IRtx683er4.c,69 :: 		for(n=0 ; n<8 ; n++){              // count 8 bits
	CLRF       chout_n_L0+0
L_chout8:
	MOVLW      8
	SUBWF      chout_n_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_chout9
;IRtx683er4.c,70 :: 		if (temp_char & 1){
	BTFSS      chout_temp_char_L0+0, 0
	GOTO       L_chout11
;IRtx683er4.c,71 :: 		send_1();
	CALL       _send_1+0
;IRtx683er4.c,72 :: 		}
	GOTO       L_chout12
L_chout11:
;IRtx683er4.c,74 :: 		send_0();
	CALL       _send_0+0
;IRtx683er4.c,75 :: 		}
L_chout12:
;IRtx683er4.c,76 :: 		temp_char = temp_char >> 1;
	RRF        chout_temp_char_L0+0, 1
	BCF        chout_temp_char_L0+0, 7
;IRtx683er4.c,69 :: 		for(n=0 ; n<8 ; n++){              // count 8 bits
	INCF       chout_n_L0+0, 1
;IRtx683er4.c,77 :: 		}
	GOTO       L_chout8
L_chout9:
;IRtx683er4.c,79 :: 		send_1();                          // stop bit
	CALL       _send_1+0
;IRtx683er4.c,80 :: 		}
L_end_chout:
	RETURN
; end of _chout

_send_0:

;IRtx683er4.c,83 :: 		void send_0(void){
;IRtx683er4.c,84 :: 		pwm_start();                    // 38KHz mark for 833 uS
	CALL       _pwm_start+0
;IRtx683er4.c,85 :: 		Delay_us(833);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      40
	MOVWF      R13+0
L_send_013:
	DECFSZ     R13+0, 1
	GOTO       L_send_013
	DECFSZ     R12+0, 1
	GOTO       L_send_013
	NOP
;IRtx683er4.c,86 :: 		}
L_end_send_0:
	RETURN
; end of _send_0

_send_1:

;IRtx683er4.c,89 :: 		void send_1(void){
;IRtx683er4.c,90 :: 		pwm_stop();                     // space  for 833 uS
	CALL       _pwm_stop+0
;IRtx683er4.c,91 :: 		Delay_us(833);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      40
	MOVWF      R13+0
L_send_114:
	DECFSZ     R13+0, 1
	GOTO       L_send_114
	DECFSZ     R12+0, 1
	GOTO       L_send_114
	NOP
;IRtx683er4.c,92 :: 		}
L_end_send_1:
	RETURN
; end of _send_1

_pwm_start:

;IRtx683er4.c,96 :: 		void pwm_start(void){
;IRtx683er4.c,97 :: 		CCP1CON = 0x3c;
	MOVLW      60
	MOVWF      CCP1CON+0
;IRtx683er4.c,98 :: 		}
L_end_pwm_start:
	RETURN
; end of _pwm_start

_pwm_stop:

;IRtx683er4.c,101 :: 		void pwm_stop(void){
;IRtx683er4.c,102 :: 		CCP1CON = 0x30;
	MOVLW      48
	MOVWF      CCP1CON+0
;IRtx683er4.c,103 :: 		}
L_end_pwm_stop:
	RETURN
; end of _pwm_stop
