#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR84Asony/IR84Asony.c"
#line 23 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR84Asony/IR84Asony.c"
sbit ir_rx at PORTA.B2;


void get_mark_time(void);



unsigned char counter = 0;
unsigned char shadow = 0;
unsigned char bitcount;
unsigned char ir_address;
unsigned char ir_command;
unsigned int mark_time;

void interrupt() {

 if (INTCON.T0IF) {
 counter++;
 INTCON.T0IF = 0;
 }
}

void main() {

 OPTION_REG = 0x04;
 TRISA = 0x04;
 PORTA = 0;
 TRISB = 0;
 PORTB = 0;


 INTCON.GIE = 1;
 INTCON.T0IE = 1;

 while(1){
 ir_command = 0;
 ir_address = 0;
 get_mark_time();
 if ((mark_time > 0x80) && (mark_time < 0xb0)){
 for(bitcount = 0 ; bitcount < 7 ; bitcount++){
 get_mark_time();
 ir_command >>= 1;
 ir_command &= 0x7f;
 if (mark_time > 0x38){
 ir_command ^= 0x80;
 }
 }
 ir_command >>= 1;
 ir_command &= 0x7F;

 for(bitcount = 0 ; bitcount < 5 ; bitcount++){
 get_mark_time();
 ir_address >>= 1;
 ir_address &= 0x7f;
 if (mark_time > 0x38){
 ir_address ^= 0x80;
 }
 }
 ir_address >>= 3;
 ir_address &= 0x1F;

 }

 if(ir_address == 1){
 if(ir_command == 0){
 shadow ^= 0x01;
 PORTB = shadow;
 }
 if(ir_command == 1){
 shadow ^= 0x02;
 PORTB = shadow;
 }
 if(ir_command == 2){
 shadow ^= 0x04;
 PORTB = shadow;
 }
 if(ir_command == 3){
 shadow ^= 0x08;
 PORTB = shadow;
 }
 if(ir_command == 4){
 shadow ^= 0x10;
 PORTB = shadow;
 }
 if(ir_command == 5){
 shadow ^= 0x20;
 PORTB = shadow;
 }
 if(ir_command == 6){
 shadow ^= 0x40;
 PORTB = shadow;
 }
 if(ir_command == 7){
 shadow ^= 0x80;
 PORTB = shadow;
 }
 if(ir_command == 8){
 shadow = 0xff;
 PORTB = shadow;
 }
 if(ir_command == 9){
 shadow = 0x00;
 PORTB = shadow;
 }
 Delay_ms(200);
 }
 }
}


void get_mark_time(void){
 while(ir_rx);
 counter=0;
 TMR0 = 0;
 while(!ir_rx);
 mark_time = (counter << 8) + TMR0;

}
