
_main:

;IRrc5.c,48 :: 		void main() {
;IRrc5.c,49 :: 		ANSELA = 0;                   // Configure PORT pins as digital
	CLRF        ANSELA+0 
;IRrc5.c,50 :: 		ANSELB = 0;                   // Configure PORT pins as digital
	CLRF        ANSELB+0 
;IRrc5.c,51 :: 		ANSELC = 0;                   // Configure PORT pins as digital
	CLRF        ANSELC+0 
;IRrc5.c,52 :: 		ANSELD = 0;                   // Configure PORT pins as digital
	CLRF        ANSELD+0 
;IRrc5.c,53 :: 		ADCON0 = 0;                   // A/D off
	CLRF        ADCON0+0 
;IRrc5.c,54 :: 		ADCON1 = 0x0f;                // all digital
	MOVLW       15
	MOVWF       ADCON1+0 
;IRrc5.c,56 :: 		CM1CON0 = 0;                  // disable 18F45K22 comparator
	CLRF        CM1CON0+0 
;IRrc5.c,57 :: 		CM2CON0 = 0;                  // disable 18F45K22 comparator
	CLRF        CM2CON0+0 
;IRrc5.c,58 :: 		T0CON = 0x86;                 // timer on 16 bit prescale 128:1
	MOVLW       134
	MOVWF       T0CON+0 
;IRrc5.c,59 :: 		TMR0L = 96;                   // Timer0 initial value
	MOVLW       96
	MOVWF       TMR0L+0 
;IRrc5.c,60 :: 		TMR0H = 0xff;
	MOVLW       255
	MOVWF       TMR0H+0 
;IRrc5.c,61 :: 		INTCON = 0x00;                // disable interrupts
	CLRF        INTCON+0 
;IRrc5.c,63 :: 		LATA = 0;                     // all off
	CLRF        LATA+0 
;IRrc5.c,64 :: 		LATB = 0x80;                  // disable GLCD if fitted
	MOVLW       128
	MOVWF       LATB+0 
;IRrc5.c,65 :: 		LATD = 0;                     // all off
	CLRF        LATD+0 
;IRrc5.c,66 :: 		LATC = 0;                     // all off
	CLRF        LATC+0 
;IRrc5.c,67 :: 		LATE = 0;                     // all off
	CLRF        LATE+0 
;IRrc5.c,68 :: 		TRISA = 0xC1;                 // all output except OSC pins
	MOVLW       193
	MOVWF       TRISA+0 
;IRrc5.c,69 :: 		TRISB = 0x81;                 // all output except b0
	MOVLW       129
	MOVWF       TRISB+0 
;IRrc5.c,70 :: 		TRISC = 0x01;                 // all output except c0
	MOVLW       1
	MOVWF       TRISC+0 
;IRrc5.c,71 :: 		TRISD = 0x00;                 // all output
	CLRF        TRISD+0 
;IRrc5.c,72 :: 		TRISE = 0;                    // all output
	CLRF        TRISE+0 
;IRrc5.c,73 :: 		ir_in_direction = 1;          // IR input
	BSF         TRISC0_bit+0, 0 
;IRrc5.c,75 :: 		Delay_ms(1000);                // Wait for LCD to stabilize
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_main0:
	DECFSZ      R13, 1, 1
	BRA         L_main0
	DECFSZ      R12, 1, 1
	BRA         L_main0
	DECFSZ      R11, 1, 1
	BRA         L_main0
;IRrc5.c,76 :: 		Lcd_Init();                            // Initialize Lcd
	CALL        _Lcd_Init+0, 0
;IRrc5.c,77 :: 		Lcd_Cmd(_LCD_CLEAR);                   // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;IRrc5.c,78 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);              // Turn cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;IRrc5.c,79 :: 		Lcd_Out(1,1, "RC5 protocol  IR");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr1_IRrc5+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr1_IRrc5+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IRrc5.c,80 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_IRrc5+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_IRrc5+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IRrc5.c,82 :: 		while(1){
L_main1:
;IRrc5.c,83 :: 		ir_result[0]=0;                                    // prevent false trigger on IR glitch
	CLRF        _ir_result+0 
;IRrc5.c,84 :: 		ir_result[1]=0;                                    // prevent false trigger on IR glitch
	CLRF        _ir_result+1 
;IRrc5.c,85 :: 		rc5_read();
	CALL        _rc5_read+0, 0
;IRrc5.c,86 :: 		if(ir_result[0]==0x0f){                            // adjust to address of YOUR remote ******
	MOVF        _ir_result+0, 0 
	XORLW       15
	BTFSS       STATUS+0, 2 
	GOTO        L_main3
;IRrc5.c,87 :: 		button = ir_result[1];
	MOVF        _ir_result+1, 0 
	MOVWF       _button+0 
;IRrc5.c,88 :: 		switch (button){
	GOTO        L_main4
;IRrc5.c,89 :: 		case 0x10: LATD.F0 = ~ LATD.F0; break;     // remote button vol+       // adjust value for YOUR remote ******
L_main6:
	BTG         LATD+0, 0 
	GOTO        L_main5
;IRrc5.c,90 :: 		case 0x11: LATD.F1 = ~ LATD.F1; break;     // remote button vol-       // adjust value for YOUR remote ******
L_main7:
	BTG         LATD+0, 1 
	GOTO        L_main5
;IRrc5.c,91 :: 		case 0x18: LATD.F2 = ~ LATD.F2; break;     // remote button treble+    // adjust value for YOUR remote ******
L_main8:
	BTG         LATD+0, 2 
	GOTO        L_main5
;IRrc5.c,92 :: 		case 0x19: LATD.F3 = ~ LATD.F3; break;     // remote button treble-    // adjust value for YOUR remote ******
L_main9:
	BTG         LATD+0, 3 
	GOTO        L_main5
;IRrc5.c,93 :: 		case 0x16: LATD.F4 = ~ LATD.F4; break;     // remote button bass+      // adjust value for YOUR remote ******
L_main10:
	BTG         LATD+0, 4 
	GOTO        L_main5
;IRrc5.c,94 :: 		case 0x17: LATD.F5 = ~ LATD.F5; break;     // remote button bass-      // adjust value for YOUR remote ******
L_main11:
	BTG         LATD+0, 5 
	GOTO        L_main5
;IRrc5.c,95 :: 		default:  break;
L_main12:
	GOTO        L_main5
;IRrc5.c,96 :: 		}
L_main4:
	MOVF        _button+0, 0 
	XORLW       16
	BTFSC       STATUS+0, 2 
	GOTO        L_main6
	MOVF        _button+0, 0 
	XORLW       17
	BTFSC       STATUS+0, 2 
	GOTO        L_main7
	MOVF        _button+0, 0 
	XORLW       24
	BTFSC       STATUS+0, 2 
	GOTO        L_main8
	MOVF        _button+0, 0 
	XORLW       25
	BTFSC       STATUS+0, 2 
	GOTO        L_main9
	MOVF        _button+0, 0 
	XORLW       22
	BTFSC       STATUS+0, 2 
	GOTO        L_main10
	MOVF        _button+0, 0 
	XORLW       23
	BTFSC       STATUS+0, 2 
	GOTO        L_main11
	GOTO        L_main12
L_main5:
;IRrc5.c,97 :: 		Delay_ms(500);                                 // limit rate of toggle
	MOVLW       21
	MOVWF       R11, 0
	MOVLW       75
	MOVWF       R12, 0
	MOVLW       190
	MOVWF       R13, 0
L_main13:
	DECFSZ      R13, 1, 1
	BRA         L_main13
	DECFSZ      R12, 1, 1
	BRA         L_main13
	DECFSZ      R11, 1, 1
	BRA         L_main13
	NOP
;IRrc5.c,98 :: 		}
L_main3:
;IRrc5.c,99 :: 		}
	GOTO        L_main1
;IRrc5.c,100 :: 		}
L_end_main:
	GOTO        $+0
; end of _main

_hexout:

;IRrc5.c,103 :: 		void hexout(unsigned char hexval){
;IRrc5.c,107 :: 		temp_hex = hexval;                     // to integer
	MOVF        FARG_hexout_hexval+0, 0 
	MOVWF       hexout_temp_hex_L0+0 
	MOVLW       0
	MOVWF       hexout_temp_hex_L0+1 
;IRrc5.c,108 :: 		IntToHex(temp_hex, hextxt);            // integer to ASCII hex
	MOVF        hexout_temp_hex_L0+0, 0 
	MOVWF       FARG_IntToHex_input+0 
	MOVF        hexout_temp_hex_L0+1, 0 
	MOVWF       FARG_IntToHex_input+1 
	MOVLW       hexout_hextxt_L0+0
	MOVWF       FARG_IntToHex_output+0 
	MOVLW       hi_addr(hexout_hextxt_L0+0)
	MOVWF       FARG_IntToHex_output+1 
	CALL        _IntToHex+0, 0
;IRrc5.c,109 :: 		keephex[0] = hextxt[2];                // store ascii hex for later
	MOVF        hexout_hextxt_L0+2, 0 
	MOVWF       _keephex+0 
;IRrc5.c,110 :: 		keephex[1] = hextxt[3];
	MOVF        hexout_hextxt_L0+3, 0 
	MOVWF       _keephex+1 
;IRrc5.c,111 :: 		keephex[2] = 0;                        // null terminate
	CLRF        _keephex+2 
;IRrc5.c,112 :: 		}
L_end_hexout:
	RETURN      0
; end of _hexout

_get_mark:

;IRrc5.c,115 :: 		int get_mark(void){
;IRrc5.c,116 :: 		TMR0H = 0;
	CLRF        TMR0H+0 
;IRrc5.c,117 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IRrc5.c,118 :: 		while(!ir_in);                       // wait for IR to go high
L_get_mark14:
	BTFSC       RC0_bit+0, 0 
	GOTO        L_get_mark15
	GOTO        L_get_mark14
L_get_mark15:
;IRrc5.c,119 :: 		LATE.F0 = 0;                         // LED off
	BCF         LATE+0, 0 
;IRrc5.c,120 :: 		retint = TMR0L;
	MOVF        TMR0L+0, 0 
	MOVWF       _retint+0 
	MOVLW       0
	MOVWF       _retint+1 
;IRrc5.c,121 :: 		retint += (TMR0H<<8);
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        _retint+0, 0 
	ADDWF       R0, 1 
	MOVF        _retint+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _retint+0 
	MOVF        R1, 0 
	MOVWF       _retint+1 
;IRrc5.c,122 :: 		return retint;
;IRrc5.c,123 :: 		}
L_end_get_mark:
	RETURN      0
; end of _get_mark

_get_space:

;IRrc5.c,126 :: 		int get_space(void){
;IRrc5.c,127 :: 		TMR0H = 0;
	CLRF        TMR0H+0 
;IRrc5.c,128 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IRrc5.c,129 :: 		while(ir_in);                        // wait for IR to go low
L_get_space16:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_get_space17
	GOTO        L_get_space16
L_get_space17:
;IRrc5.c,130 :: 		LATE.F0 = 1;                         // LED on
	BSF         LATE+0, 0 
;IRrc5.c,131 :: 		retint = TMR0L;
	MOVF        TMR0L+0, 0 
	MOVWF       _retint+0 
	MOVLW       0
	MOVWF       _retint+1 
;IRrc5.c,132 :: 		retint += (TMR0H<<8);
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        _retint+0, 0 
	ADDWF       R0, 1 
	MOVF        _retint+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _retint+0 
	MOVF        R1, 0 
	MOVWF       _retint+1 
;IRrc5.c,133 :: 		return retint;
;IRrc5.c,134 :: 		}
L_end_get_space:
	RETURN      0
; end of _get_space

_rc5_read:

;IRrc5.c,145 :: 		void rc5_read(void){
;IRrc5.c,150 :: 		rc5_byte1=0;                          // init
	CLRF        rc5_read_rc5_byte1_L0+0 
;IRrc5.c,151 :: 		rc5_byte2=0;                          // init
	CLRF        rc5_read_rc5_byte2_L0+0 
;IRrc5.c,152 :: 		while(ir_in);                         // wait for IR to go low
L_rc5_read18:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_rc5_read19
	GOTO        L_rc5_read18
L_rc5_read19:
;IRrc5.c,154 :: 		irwas2t = 0;                                   // init
	CLRF        _irwas2t+0 
;IRrc5.c,155 :: 		irnowm = 0;                                    // init
	CLRF        _irnowm+0 
;IRrc5.c,156 :: 		temp_ir = get_mark();                          // second half of start bit 1
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       rc5_read_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc5_read_temp_ir_L0+1 
;IRrc5.c,157 :: 		if ((temp_ir > 40) && (temp_ir < 80)){         // expect 890uS mark start bit1
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc5_read45
	MOVF        R0, 0 
	SUBLW       40
L__rc5_read45:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc5_read22
	MOVLW       128
	XORWF       rc5_read_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc5_read46
	MOVLW       80
	SUBWF       rc5_read_temp_ir_L0+0, 0 
L__rc5_read46:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc5_read22
L__rc5_read39:
;IRrc5.c,158 :: 		rc5_byte1 = get_rc5_byte(7);               // start bit2 '1' + toggle + 5 bit address
	MOVLW       7
	MOVWF       FARG_get_rc5_byte_nbits+0 
	CALL        _get_rc5_byte+0, 0
	MOVF        R0, 0 
	MOVWF       rc5_read_rc5_byte1_L0+0 
;IRrc5.c,159 :: 		rc5_byte2 = get_rc5_byte(6);               // 6 bit command
	MOVLW       6
	MOVWF       FARG_get_rc5_byte_nbits+0 
	CALL        _get_rc5_byte+0, 0
	MOVF        R0, 0 
	MOVWF       rc5_read_rc5_byte2_L0+0 
;IRrc5.c,160 :: 		Lcd_Out(2,1, "t=0 ad=   cmd=  ");          // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr3_IRrc5+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr3_IRrc5+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IRrc5.c,161 :: 		if (rc5_byte1 & 0x20){
	BTFSS       rc5_read_rc5_byte1_L0+0, 5 
	GOTO        L_rc5_read23
;IRrc5.c,162 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IRrc5.c,163 :: 		}
	GOTO        L_rc5_read24
L_rc5_read23:
;IRrc5.c,165 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IRrc5.c,166 :: 		}
L_rc5_read24:
;IRrc5.c,167 :: 		hexout(rc5_byte1 & 0x1F);                  // 5 bits address
	MOVLW       31
	ANDWF       rc5_read_rc5_byte1_L0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IRrc5.c,168 :: 		Lcd_Chr(2,8,keephex[0]);               // recover character stored by hexout function
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IRrc5.c,169 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IRrc5.c,170 :: 		hexout(rc5_byte2);
	MOVF        rc5_read_rc5_byte2_L0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IRrc5.c,171 :: 		Lcd_Chr(2,15,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IRrc5.c,172 :: 		Lcd_Chr(2,16,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IRrc5.c,173 :: 		Delay_ms(100);                              // wait for repeat messages to clear
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_rc5_read25:
	DECFSZ      R13, 1, 1
	BRA         L_rc5_read25
	DECFSZ      R12, 1, 1
	BRA         L_rc5_read25
	DECFSZ      R11, 1, 1
	BRA         L_rc5_read25
;IRrc5.c,174 :: 		}
L_rc5_read22:
;IRrc5.c,175 :: 		ir_result[0]=rc5_byte1&0x1f;                    // read only 5 address bits
	MOVLW       31
	ANDWF       rc5_read_rc5_byte1_L0+0, 0 
	MOVWF       _ir_result+0 
;IRrc5.c,176 :: 		ir_result[1]=rc5_byte2&0x3f;                    // read only 6 command bits
	MOVLW       63
	ANDWF       rc5_read_rc5_byte2_L0+0, 0 
	MOVWF       _ir_result+1 
;IRrc5.c,177 :: 		}
L_end_rc5_read:
	RETURN      0
; end of _rc5_read

_get_rc5_byte:

;IRrc5.c,180 :: 		unsigned char get_rc5_byte(char nbits){
;IRrc5.c,183 :: 		irbyte = 0;                                  // initialise
	CLRF        _irbyte+0 
;IRrc5.c,184 :: 		for(n = 0 ; n < nbits ; n++){
	CLRF        get_rc5_byte_n_L0+0 
L_get_rc5_byte26:
	MOVF        FARG_get_rc5_byte_nbits+0, 0 
	SUBWF       get_rc5_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_rc5_byte27
;IRrc5.c,185 :: 		getrc5bit();
	CALL        _getrc5bit+0, 0
;IRrc5.c,184 :: 		for(n = 0 ; n < nbits ; n++){
	INCF        get_rc5_byte_n_L0+0, 1 
;IRrc5.c,186 :: 		}
	GOTO        L_get_rc5_byte26
L_get_rc5_byte27:
;IRrc5.c,187 :: 		return irbyte;
	MOVF        _irbyte+0, 0 
	MOVWF       R0 
;IRrc5.c,188 :: 		}
L_end_get_rc5_byte:
	RETURN      0
; end of _get_rc5_byte

_getrc5bit:

;IRrc5.c,191 :: 		void getrc5bit(void){
;IRrc5.c,193 :: 		if(!irnowm){
	MOVF        _irnowm+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc5bit29
;IRrc5.c,195 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc5bit30
;IRrc5.c,197 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IRrc5.c,198 :: 		temp_bit_s = get_space();                         // get 1st half of bit
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IRrc5.c,199 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IRrc5.c,200 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IRrc5.c,201 :: 		if(temp_bit_m < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit49
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit49:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit31
	CLRF        _irwas2t+0 
L_getrc5bit31:
;IRrc5.c,202 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IRrc5.c,203 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IRrc5.c,204 :: 		}
	GOTO        L_getrc5bit32
L_getrc5bit30:
;IRrc5.c,207 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IRrc5.c,208 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IRrc5.c,209 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IRrc5.c,210 :: 		if(temp_bit_s < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit50
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit50:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit33
	CLRF        _irwas2t+0 
L_getrc5bit33:
;IRrc5.c,211 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IRrc5.c,212 :: 		}
L_getrc5bit32:
;IRrc5.c,213 :: 		}
	GOTO        L_getrc5bit34
L_getrc5bit29:
;IRrc5.c,216 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc5bit35
;IRrc5.c,218 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IRrc5.c,219 :: 		temp_bit_m = get_mark();                          // get 1st half of bit
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IRrc5.c,220 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IRrc5.c,221 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IRrc5.c,222 :: 		if(temp_bit_s < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit51
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit51:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit36
	CLRF        _irwas2t+0 
L_getrc5bit36:
;IRrc5.c,223 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IRrc5.c,224 :: 		}
	GOTO        L_getrc5bit37
L_getrc5bit35:
;IRrc5.c,227 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IRrc5.c,228 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IRrc5.c,229 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IRrc5.c,230 :: 		if(temp_bit_m < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit52
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit52:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit38
	CLRF        _irwas2t+0 
L_getrc5bit38:
;IRrc5.c,231 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IRrc5.c,232 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IRrc5.c,233 :: 		}
L_getrc5bit37:
;IRrc5.c,234 :: 		}
L_getrc5bit34:
;IRrc5.c,235 :: 		}
L_end_getrc5bit:
	RETURN      0
; end of _getrc5bit
