
_main:

;IRsony.c,28 :: 		void main() {
;IRsony.c,29 :: 		ANSELA = 0;                   // Configure PORT pins as digital
	CLRF        ANSELA+0 
;IRsony.c,30 :: 		ANSELB = 0;                   // Configure PORT pins as digital
	CLRF        ANSELB+0 
;IRsony.c,31 :: 		ANSELC = 0;                   // Configure PORT pins as digital
	CLRF        ANSELC+0 
;IRsony.c,32 :: 		ANSELD = 0;                   // Configure PORT pins as digital
	CLRF        ANSELD+0 
;IRsony.c,33 :: 		ADCON0 = 0;                   // A/D off
	CLRF        ADCON0+0 
;IRsony.c,34 :: 		ADCON1 = 0x0f;                // all digital
	MOVLW       15
	MOVWF       ADCON1+0 
;IRsony.c,36 :: 		CM1CON0 = 0;                  // disable 18F45K22 comparator
	CLRF        CM1CON0+0 
;IRsony.c,37 :: 		CM2CON0 = 0;                  // disable 18F45K22 comparator
	CLRF        CM2CON0+0 
;IRsony.c,38 :: 		T0CON = 0x86;                 // timer on 16 bit prescale 128:1
	MOVLW       134
	MOVWF       T0CON+0 
;IRsony.c,39 :: 		TMR0L = 96;                   // Timer0 initial value
	MOVLW       96
	MOVWF       TMR0L+0 
;IRsony.c,40 :: 		TMR0H = 0xff;
	MOVLW       255
	MOVWF       TMR0H+0 
;IRsony.c,41 :: 		INTCON = 0x00;                // Disable interrupts
	CLRF        INTCON+0 
;IRsony.c,43 :: 		LATA = 0;                     // all off
	CLRF        LATA+0 
;IRsony.c,44 :: 		LATB = 0x80;                  // disable GLCD if fitted
	MOVLW       128
	MOVWF       LATB+0 
;IRsony.c,45 :: 		LATC = 0;                     // all off
	CLRF        LATC+0 
;IRsony.c,46 :: 		LATD = 0;                     // all off
	CLRF        LATD+0 
;IRsony.c,47 :: 		LATE = 0;                     // all off
	CLRF        LATE+0 
;IRsony.c,48 :: 		TRISA = 0xC1;                 // all output except OSC pins
	MOVLW       193
	MOVWF       TRISA+0 
;IRsony.c,49 :: 		TRISB = 0x81;                 // all output except b0,b7
	MOVLW       129
	MOVWF       TRISB+0 
;IRsony.c,50 :: 		TRISC = 0x01;                 // all output except c0
	MOVLW       1
	MOVWF       TRISC+0 
;IRsony.c,51 :: 		TRISD = 0x00;                 // all output
	CLRF        TRISD+0 
;IRsony.c,52 :: 		TRISE = 0;                    // all output
	CLRF        TRISE+0 
;IRsony.c,53 :: 		ir_in_direction = 1;          // IR input
	BSF         TRISC0_bit+0, 0 
;IRsony.c,55 :: 		Delay_ms(1000);                // Wait for LCD to stabilize
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_main0:
	DECFSZ      R13, 1, 1
	BRA         L_main0
	DECFSZ      R12, 1, 1
	BRA         L_main0
	DECFSZ      R11, 1, 1
	BRA         L_main0
;IRsony.c,57 :: 		while(1){
L_main1:
;IRsony.c,58 :: 		sony_read();
	CALL        _sony_read+0, 0
;IRsony.c,59 :: 		if(ir_result[1]==1){                 // Sony address 01 is TV
	MOVF        _ir_result+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_main3
;IRsony.c,60 :: 		button = ir_result[0];
	MOVF        _ir_result+0, 0 
	MOVWF       _button+0 
;IRsony.c,61 :: 		switch (button){
	GOTO        L_main4
;IRsony.c,62 :: 		case 9: LATD.F0 = ~LATD.F0;break;        // button TV '0'
L_main6:
	BTG         LATD+0, 0 
	GOTO        L_main5
;IRsony.c,63 :: 		case 0: LATD.F1 = ~LATD.F1;break;        // button TV '1'
L_main7:
	BTG         LATD+0, 1 
	GOTO        L_main5
;IRsony.c,64 :: 		case 1: LATD.F2 = ~LATD.F2;break;        // button TV '2'
L_main8:
	BTG         LATD+0, 2 
	GOTO        L_main5
;IRsony.c,65 :: 		case 2: LATD.F3 = ~LATD.F3;break;        // button TV '3'
L_main9:
	BTG         LATD+0, 3 
	GOTO        L_main5
;IRsony.c,66 :: 		case 3: LATD.F4 = ~LATD.F4;break;        // button TV '4'
L_main10:
	BTG         LATD+0, 4 
	GOTO        L_main5
;IRsony.c,67 :: 		case 4: LATD.F5 = ~LATD.F5;break;        // button TV '5'
L_main11:
	BTG         LATD+0, 5 
	GOTO        L_main5
;IRsony.c,68 :: 		case 5: LATD.F6 = ~LATD.F6;break;        // button TV '6'
L_main12:
	BTG         LATD+0, 6 
	GOTO        L_main5
;IRsony.c,69 :: 		case 6: LATD.F7 = ~LATD.F7;break;        // button TV '7'
L_main13:
	BTG         LATD+0, 7 
	GOTO        L_main5
;IRsony.c,70 :: 		case 7: LATD = 0x00;break;               // button TV '8'
L_main14:
	CLRF        LATD+0 
	GOTO        L_main5
;IRsony.c,71 :: 		case 8: LATD = 0xff;break;               // button TV '9'
L_main15:
	MOVLW       255
	MOVWF       LATD+0 
	GOTO        L_main5
;IRsony.c,72 :: 		default:break;
L_main16:
	GOTO        L_main5
;IRsony.c,73 :: 		}
L_main4:
	MOVF        _button+0, 0 
	XORLW       9
	BTFSC       STATUS+0, 2 
	GOTO        L_main6
	MOVF        _button+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main7
	MOVF        _button+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_main8
	MOVF        _button+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_main9
	MOVF        _button+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_main10
	MOVF        _button+0, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_main11
	MOVF        _button+0, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_main12
	MOVF        _button+0, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_main13
	MOVF        _button+0, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L_main14
	MOVF        _button+0, 0 
	XORLW       8
	BTFSC       STATUS+0, 2 
	GOTO        L_main15
	GOTO        L_main16
L_main5:
;IRsony.c,74 :: 		}
L_main3:
;IRsony.c,75 :: 		delay_ms(500);                                   // limit toggle rate
	MOVLW       21
	MOVWF       R11, 0
	MOVLW       75
	MOVWF       R12, 0
	MOVLW       190
	MOVWF       R13, 0
L_main17:
	DECFSZ      R13, 1, 1
	BRA         L_main17
	DECFSZ      R12, 1, 1
	BRA         L_main17
	DECFSZ      R11, 1, 1
	BRA         L_main17
	NOP
;IRsony.c,76 :: 		}
	GOTO        L_main1
;IRsony.c,78 :: 		}
L_end_main:
	GOTO        $+0
; end of _main

_get_mark:

;IRsony.c,81 :: 		int get_mark(void){
;IRsony.c,82 :: 		TMR0H = 0;
	CLRF        TMR0H+0 
;IRsony.c,83 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IRsony.c,84 :: 		while(!ir_in);                       // wait for IR to go high
L_get_mark20:
	BTFSC       RC0_bit+0, 0 
	GOTO        L_get_mark21
	GOTO        L_get_mark20
L_get_mark21:
;IRsony.c,85 :: 		LATE.F0 = 0;                         // LED off
	BCF         LATE+0, 0 
;IRsony.c,86 :: 		retint = TMR0L;
	MOVF        TMR0L+0, 0 
	MOVWF       _retint+0 
	MOVLW       0
	MOVWF       _retint+1 
;IRsony.c,87 :: 		retint += (TMR0H<<8);
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        _retint+0, 0 
	ADDWF       R0, 1 
	MOVF        _retint+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _retint+0 
	MOVF        R1, 0 
	MOVWF       _retint+1 
;IRsony.c,88 :: 		return retint;
;IRsony.c,89 :: 		}
L_end_get_mark:
	RETURN      0
; end of _get_mark

_get_space:

;IRsony.c,92 :: 		int get_space(void){
;IRsony.c,93 :: 		TMR0H = 0;
	CLRF        TMR0H+0 
;IRsony.c,94 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IRsony.c,95 :: 		while(ir_in);                        // wait for IR to go low
L_get_space22:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_get_space23
	GOTO        L_get_space22
L_get_space23:
;IRsony.c,96 :: 		LATE.F0 = 1;                         // LED on
	BSF         LATE+0, 0 
;IRsony.c,97 :: 		retint = TMR0L;
	MOVF        TMR0L+0, 0 
	MOVWF       _retint+0 
	MOVLW       0
	MOVWF       _retint+1 
;IRsony.c,98 :: 		retint += (TMR0H<<8);
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        _retint+0, 0 
	ADDWF       R0, 1 
	MOVF        _retint+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _retint+0 
	MOVF        R1, 0 
	MOVWF       _retint+1 
;IRsony.c,99 :: 		return retint;
;IRsony.c,100 :: 		}
L_end_get_space:
	RETURN      0
; end of _get_space

_sony_read:

;IRsony.c,124 :: 		void sony_read(void){
;IRsony.c,127 :: 		ir_result[0] = 0;                            // return 0, 0 if glitch
	CLRF        _ir_result+0 
;IRsony.c,128 :: 		ir_result[1] = 0;                            // return 0, 0 if glitch
	CLRF        _ir_result+1 
;IRsony.c,129 :: 		while(ir_in);                                // wait for IR to go low
L_sony_read24:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_sony_read25
	GOTO        L_sony_read24
L_sony_read25:
;IRsony.c,131 :: 		temp_mk = get_mark();
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       sony_read_temp_mk_L0+0 
	MOVF        R1, 0 
	MOVWF       sony_read_temp_mk_L0+1 
;IRsony.c,132 :: 		if ((temp_mk > 120) && (temp_mk < 200)){     // expect 2.4mS mark
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sony_read39
	MOVF        R0, 0 
	SUBLW       120
L__sony_read39:
	BTFSC       STATUS+0, 0 
	GOTO        L_sony_read28
	MOVLW       128
	XORWF       sony_read_temp_mk_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sony_read40
	MOVLW       200
	SUBWF       sony_read_temp_mk_L0+0, 0 
L__sony_read40:
	BTFSC       STATUS+0, 0 
	GOTO        L_sony_read28
L__sony_read34:
;IRsony.c,133 :: 		ir_result[0] = get_sony_byte(7);         // 7 bit command
	MOVLW       7
	MOVWF       FARG_get_sony_byte_nbits+0 
	CALL        _get_sony_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+0 
;IRsony.c,134 :: 		ir_result[1] = get_sony_byte(5);         // 5 bit address
	MOVLW       5
	MOVWF       FARG_get_sony_byte_nbits+0 
	CALL        _get_sony_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IRsony.c,135 :: 		Delay_ms(10);             // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_sony_read29:
	DECFSZ      R13, 1, 1
	BRA         L_sony_read29
	DECFSZ      R12, 1, 1
	BRA         L_sony_read29
	NOP
;IRsony.c,136 :: 		}
L_sony_read28:
;IRsony.c,137 :: 		}
L_end_sony_read:
	RETURN      0
; end of _sony_read

_get_sony_byte:

;IRsony.c,140 :: 		unsigned char get_sony_byte(char nbits){
;IRsony.c,145 :: 		ir_byte = 0;                                  // initialise
	CLRF        get_sony_byte_ir_byte_L0+0 
;IRsony.c,146 :: 		for(n=0 ; n<nbits ; n++){
	CLRF        get_sony_byte_n_L0+0 
L_get_sony_byte30:
	MOVF        FARG_get_sony_byte_nbits+0, 0 
	SUBWF       get_sony_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sony_byte31
;IRsony.c,147 :: 		temp_ir = get_space();                    // expect ~510uS
	CALL        _get_space+0, 0
;IRsony.c,148 :: 		temp_ir = get_mark();                     // 650uS = 0, 1.2uS = 1
	CALL        _get_mark+0, 0
;IRsony.c,149 :: 		ir_byte >>= 1;
	RRCF        get_sony_byte_ir_byte_L0+0, 1 
	BCF         get_sony_byte_ir_byte_L0+0, 7 
;IRsony.c,150 :: 		if (temp_ir > 60){                        //
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_sony_byte42
	MOVF        R0, 0 
	SUBLW       60
L__get_sony_byte42:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sony_byte33
;IRsony.c,151 :: 		ir_byte += 0x80;
	MOVLW       128
	ADDWF       get_sony_byte_ir_byte_L0+0, 1 
;IRsony.c,152 :: 		}
L_get_sony_byte33:
;IRsony.c,146 :: 		for(n=0 ; n<nbits ; n++){
	INCF        get_sony_byte_n_L0+0, 1 
;IRsony.c,153 :: 		}
	GOTO        L_get_sony_byte30
L_get_sony_byte31:
;IRsony.c,154 :: 		ir_byte >>= 8-nbits;                          // convert 5/7 bits to 8
	MOVF        FARG_get_sony_byte_nbits+0, 0 
	SUBLW       8
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       R1 
	MOVF        get_sony_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
	MOVF        R1, 0 
L__get_sony_byte43:
	BZ          L__get_sony_byte44
	RRCF        R0, 1 
	BCF         R0, 7 
	ADDLW       255
	GOTO        L__get_sony_byte43
L__get_sony_byte44:
	MOVF        R0, 0 
	MOVWF       get_sony_byte_ir_byte_L0+0 
;IRsony.c,155 :: 		return ir_byte;
;IRsony.c,156 :: 		}
L_end_get_sony_byte:
	RETURN      0
; end of _get_sony_byte
