#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRsony/IRsony.c"










sbit ir_in at RC0_bit;
sbit ir_in_direction at TRISC0_bit;


unsigned int retint;
signed int temp_bit_s;
signed int temp_bit_m;
unsigned char ir_byte;
unsigned char ir_result[5];
unsigned char button;


void sony_read(void);
int get_mark(void);
int get_space(void);
unsigned char get_sony_byte(char nbits);

void main() {
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ADCON0 = 0;
 ADCON1 = 0x0f;

 CM1CON0 = 0;
 CM2CON0 = 0;
 T0CON = 0x86;
 TMR0L = 96;
 TMR0H = 0xff;
 INTCON = 0x00;

 LATA = 0;
 LATB = 0x80;
 LATC = 0;
 LATD = 0;
 LATE = 0;
 TRISA = 0xC1;
 TRISB = 0x81;
 TRISC = 0x01;
 TRISD = 0x00;
 TRISE = 0;
 ir_in_direction = 1;

 Delay_ms(1000);

 while(1){
 sony_read();
 if(ir_result[1]==1){
 button = ir_result[0];
 switch (button){
 case 9: LATD.F0 = ~LATD.F0;break;
 case 0: LATD.F1 = ~LATD.F1;break;
 case 1: LATD.F2 = ~LATD.F2;break;
 case 2: LATD.F3 = ~LATD.F3;break;
 case 3: LATD.F4 = ~LATD.F4;break;
 case 4: LATD.F5 = ~LATD.F5;break;
 case 5: LATD.F6 = ~LATD.F6;break;
 case 6: LATD.F7 = ~LATD.F7;break;
 case 7: LATD = 0x00;break;
 case 8: LATD = 0xff;break;
 default:break;
 }
 }
 delay_ms(500);
 }
 while(1);
}


int get_mark(void){
 TMR0H = 0;
 TMR0L = 0;
 while(!ir_in);
 LATE.F0 = 0;
 retint = TMR0L;
 retint += (TMR0H<<8);
 return retint;
}


int get_space(void){
 TMR0H = 0;
 TMR0L = 0;
 while(ir_in);
 LATE.F0 = 1;
 retint = TMR0L;
 retint += (TMR0H<<8);
 return retint;
}
#line 124 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRsony/IRsony.c"
void sony_read(void){
signed int temp_mk;

 ir_result[0] = 0;
 ir_result[1] = 0;
 while(ir_in);

 temp_mk = get_mark();
 if ((temp_mk > 120) && (temp_mk < 200)){
 ir_result[0] = get_sony_byte(7);
 ir_result[1] = get_sony_byte(5);
 Delay_ms(10);
 }
}


unsigned char get_sony_byte(char nbits){
char n;
unsigned char ir_byte;
signed int temp_ir;

 ir_byte = 0;
 for(n=0 ; n<nbits ; n++){
 temp_ir = get_space();
 temp_ir = get_mark();
 ir_byte >>= 1;
 if (temp_ir > 60){
 ir_byte += 0x80;
 }
 }
 ir_byte >>= 8-nbits;
 return ir_byte;
}
