#line 1 "C:/PIC/MikroC/PIC16/PIC16F628/IRtx628Sony/IRtx628sony.c"
#line 13 "C:/PIC/MikroC/PIC16/PIC16F628/IRtx628Sony/IRtx628sony.c"
void pwm_start(void);
void pwm_stop(void);
void send_1(void);
void send_0(void);

void main() {
unsigned char sony_address;
unsigned char sony_command;
char n;

 CMCON = 7;
 PORTA = 0;
 TRISA = 0xff;
 TRISB = 0xf7;
 OPTION_REG.B7 = 0;

 T2CON = 0x04;
 PR2 = 0x31;
 CCPR1L = 0x17;
 CCP1CON = 0x30;

 while (1){
 if((PORTB & 0x27) != 0x27){
 sony_address = 0;
 sony_command = 0;
 if (!PORTB.B0){
 sony_address = 1;
 sony_command = 0;
 }
 if (!PORTB.B1){
 sony_address = 1;
 sony_command = 1;
 }
 if (!PORTB.B2){
 sony_address = 1;
 sony_command = 2;
 }
 if (!PORTB.B5){
 sony_address = 1;
 sony_command = 3;
 }
 pwm_start();
 Delay_us(2400);
 pwm_stop();
 Delay_us(1200);
 for(n=0; n<7 ; n++){
 if(sony_command & (1<<n)){
 send_1();
 }
 else{
 send_0();
 }
 }
 for(n=0; n<5 ; n++){
 if(sony_address & (1<<n)){
 send_1();
 }
 else{
 send_0();
 }
 }
 pwm_stop();
 Delay_ms(300);
 }
 }
}


void send_0(void){
 pwm_start();
 Delay_us(600);
 pwm_stop();
 Delay_us(600);
}


void send_1(void){
 pwm_start();
 Delay_us(1200);
 pwm_stop();
 Delay_us(600);
}



void pwm_start(void){
 CCP1CON = 0x3c;
}


void pwm_stop(void){
 CCP1CON = 0x30;
}
