#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRtx683er4/IRtx683er4.c"
#line 13 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRtx683er4/IRtx683er4.c"
void pwm_start(void);
void pwm_stop(void);
void chout(unsigned char ch_to_send);
void send_1(void);
void send_0(void);

void main() {
char n;

 OSCCON = 0x71;

 ADCON0 = 0;
 ANSEL = 0;
 CMCON0 = 7;
 GPIO = 0;
 TRISIO = 0xfb;
 WPU = 0x33;
 OPTION_REG.B7 = 0;

 T2CON = 0x04;
 PR2 = 0x33;
 CCPR1L = 0x18;
 CCP1CON = 0x30;

 while (1){
 if((GPIO & 0x33) != 0x33){
 if (!GPIO.B0){
 chout('A');
 chout('a');
 }
 if (!GPIO.B1){
 chout('B');
 chout('b');
 }
 if (!GPIO.B4){
 chout('C');
 chout('c');
 }
 if (!GPIO.B5){
 chout('D');
 chout('d');
 }
 pwm_stop();
 Delay_ms(300);
 }
 }
}


void chout(unsigned char ch_to_send){
char n;
unsigned char temp_char;

 temp_char = ch_to_send;
 send_0();

 for(n=0 ; n<8 ; n++){
 if (temp_char & 1){
 send_1();
 }
 else{
 send_0();
 }
 temp_char = temp_char >> 1;
 }

 send_1();
}


void send_0(void){
 pwm_start();
 Delay_us(833);
}


void send_1(void){
 pwm_stop();
 Delay_us(833);
}



void pwm_start(void){
 CCP1CON = 0x3c;
}


void pwm_stop(void){
 CCP1CON = 0x30;
}
